(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define(['exports', 'react', 'rxjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.ReactRedux = {}, global.React, global.rxjs));
})(this, (function (exports, React, rxjs) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function isFunction(x) {
        return typeof x === 'function';
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var _enable_super_gross_mode_that_will_cause_bad_things = false;
    var config = {
        Promise: undefined,
        set useDeprecatedSynchronousErrorHandling(value) {
            if (value) {
                var error = /*@__PURE__*/ new Error();
                /*@__PURE__*/ console.warn('DEPRECATED! RxJS was set to use deprecated synchronous error handling behavior by code at: \n' + error.stack);
            }
            _enable_super_gross_mode_that_will_cause_bad_things = value;
        },
        get useDeprecatedSynchronousErrorHandling() {
            return _enable_super_gross_mode_that_will_cause_bad_things;
        },
    };

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function hostReportError(err) {
        setTimeout(function () { throw err; }, 0);
    }

    /** PURE_IMPORTS_START _config,_util_hostReportError PURE_IMPORTS_END */
    var empty$1 = {
        closed: true,
        next: function (value) { },
        error: function (err) {
            if (config.useDeprecatedSynchronousErrorHandling) {
                throw err;
            }
            else {
                hostReportError(err);
            }
        },
        complete: function () { }
    };

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var isArray = /*@__PURE__*/ (function () { return Array.isArray || (function (x) { return x && typeof x.length === 'number'; }); })();

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function isObject(x) {
        return x !== null && typeof x === 'object';
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var UnsubscriptionErrorImpl = /*@__PURE__*/ (function () {
        function UnsubscriptionErrorImpl(errors) {
            Error.call(this);
            this.message = errors ?
                errors.length + " errors occurred during unsubscription:\n" + errors.map(function (err, i) { return i + 1 + ") " + err.toString(); }).join('\n  ') : '';
            this.name = 'UnsubscriptionError';
            this.errors = errors;
            return this;
        }
        UnsubscriptionErrorImpl.prototype = /*@__PURE__*/ Object.create(Error.prototype);
        return UnsubscriptionErrorImpl;
    })();
    var UnsubscriptionError = UnsubscriptionErrorImpl;

    /** PURE_IMPORTS_START _util_isArray,_util_isObject,_util_isFunction,_util_UnsubscriptionError PURE_IMPORTS_END */
    var Subscription = /*@__PURE__*/ (function () {
        function Subscription(unsubscribe) {
            this.closed = false;
            this._parentOrParents = null;
            this._subscriptions = null;
            if (unsubscribe) {
                this._ctorUnsubscribe = true;
                this._unsubscribe = unsubscribe;
            }
        }
        Subscription.prototype.unsubscribe = function () {
            var errors;
            if (this.closed) {
                return;
            }
            var _a = this, _parentOrParents = _a._parentOrParents, _ctorUnsubscribe = _a._ctorUnsubscribe, _unsubscribe = _a._unsubscribe, _subscriptions = _a._subscriptions;
            this.closed = true;
            this._parentOrParents = null;
            this._subscriptions = null;
            if (_parentOrParents instanceof Subscription) {
                _parentOrParents.remove(this);
            }
            else if (_parentOrParents !== null) {
                for (var index = 0; index < _parentOrParents.length; ++index) {
                    var parent_1 = _parentOrParents[index];
                    parent_1.remove(this);
                }
            }
            if (isFunction(_unsubscribe)) {
                if (_ctorUnsubscribe) {
                    this._unsubscribe = undefined;
                }
                try {
                    _unsubscribe.call(this);
                }
                catch (e) {
                    errors = e instanceof UnsubscriptionError ? flattenUnsubscriptionErrors(e.errors) : [e];
                }
            }
            if (isArray(_subscriptions)) {
                var index = -1;
                var len = _subscriptions.length;
                while (++index < len) {
                    var sub = _subscriptions[index];
                    if (isObject(sub)) {
                        try {
                            sub.unsubscribe();
                        }
                        catch (e) {
                            errors = errors || [];
                            if (e instanceof UnsubscriptionError) {
                                errors = errors.concat(flattenUnsubscriptionErrors(e.errors));
                            }
                            else {
                                errors.push(e);
                            }
                        }
                    }
                }
            }
            if (errors) {
                throw new UnsubscriptionError(errors);
            }
        };
        Subscription.prototype.add = function (teardown) {
            var subscription = teardown;
            if (!teardown) {
                return Subscription.EMPTY;
            }
            switch (typeof teardown) {
                case 'function':
                    subscription = new Subscription(teardown);
                case 'object':
                    if (subscription === this || subscription.closed || typeof subscription.unsubscribe !== 'function') {
                        return subscription;
                    }
                    else if (this.closed) {
                        subscription.unsubscribe();
                        return subscription;
                    }
                    else if (!(subscription instanceof Subscription)) {
                        var tmp = subscription;
                        subscription = new Subscription();
                        subscription._subscriptions = [tmp];
                    }
                    break;
                default: {
                    throw new Error('unrecognized teardown ' + teardown + ' added to Subscription.');
                }
            }
            var _parentOrParents = subscription._parentOrParents;
            if (_parentOrParents === null) {
                subscription._parentOrParents = this;
            }
            else if (_parentOrParents instanceof Subscription) {
                if (_parentOrParents === this) {
                    return subscription;
                }
                subscription._parentOrParents = [_parentOrParents, this];
            }
            else if (_parentOrParents.indexOf(this) === -1) {
                _parentOrParents.push(this);
            }
            else {
                return subscription;
            }
            var subscriptions = this._subscriptions;
            if (subscriptions === null) {
                this._subscriptions = [subscription];
            }
            else {
                subscriptions.push(subscription);
            }
            return subscription;
        };
        Subscription.prototype.remove = function (subscription) {
            var subscriptions = this._subscriptions;
            if (subscriptions) {
                var subscriptionIndex = subscriptions.indexOf(subscription);
                if (subscriptionIndex !== -1) {
                    subscriptions.splice(subscriptionIndex, 1);
                }
            }
        };
        Subscription.EMPTY = (function (empty) {
            empty.closed = true;
            return empty;
        }(new Subscription()));
        return Subscription;
    }());
    function flattenUnsubscriptionErrors(errors) {
        return errors.reduce(function (errs, err) { return errs.concat((err instanceof UnsubscriptionError) ? err.errors : err); }, []);
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var rxSubscriber = /*@__PURE__*/ (function () {
        return typeof Symbol === 'function'
            ? /*@__PURE__*/ Symbol('rxSubscriber')
            : '@@rxSubscriber_' + /*@__PURE__*/ Math.random();
    })();

    /** PURE_IMPORTS_START tslib,_util_isFunction,_Observer,_Subscription,_internal_symbol_rxSubscriber,_config,_util_hostReportError PURE_IMPORTS_END */
    var Subscriber = /*@__PURE__*/ (function (_super) {
        __extends(Subscriber, _super);
        function Subscriber(destinationOrNext, error, complete) {
            var _this = _super.call(this) || this;
            _this.syncErrorValue = null;
            _this.syncErrorThrown = false;
            _this.syncErrorThrowable = false;
            _this.isStopped = false;
            switch (arguments.length) {
                case 0:
                    _this.destination = empty$1;
                    break;
                case 1:
                    if (!destinationOrNext) {
                        _this.destination = empty$1;
                        break;
                    }
                    if (typeof destinationOrNext === 'object') {
                        if (destinationOrNext instanceof Subscriber) {
                            _this.syncErrorThrowable = destinationOrNext.syncErrorThrowable;
                            _this.destination = destinationOrNext;
                            destinationOrNext.add(_this);
                        }
                        else {
                            _this.syncErrorThrowable = true;
                            _this.destination = new SafeSubscriber(_this, destinationOrNext);
                        }
                        break;
                    }
                default:
                    _this.syncErrorThrowable = true;
                    _this.destination = new SafeSubscriber(_this, destinationOrNext, error, complete);
                    break;
            }
            return _this;
        }
        Subscriber.prototype[rxSubscriber] = function () { return this; };
        Subscriber.create = function (next, error, complete) {
            var subscriber = new Subscriber(next, error, complete);
            subscriber.syncErrorThrowable = false;
            return subscriber;
        };
        Subscriber.prototype.next = function (value) {
            if (!this.isStopped) {
                this._next(value);
            }
        };
        Subscriber.prototype.error = function (err) {
            if (!this.isStopped) {
                this.isStopped = true;
                this._error(err);
            }
        };
        Subscriber.prototype.complete = function () {
            if (!this.isStopped) {
                this.isStopped = true;
                this._complete();
            }
        };
        Subscriber.prototype.unsubscribe = function () {
            if (this.closed) {
                return;
            }
            this.isStopped = true;
            _super.prototype.unsubscribe.call(this);
        };
        Subscriber.prototype._next = function (value) {
            this.destination.next(value);
        };
        Subscriber.prototype._error = function (err) {
            this.destination.error(err);
            this.unsubscribe();
        };
        Subscriber.prototype._complete = function () {
            this.destination.complete();
            this.unsubscribe();
        };
        Subscriber.prototype._unsubscribeAndRecycle = function () {
            var _parentOrParents = this._parentOrParents;
            this._parentOrParents = null;
            this.unsubscribe();
            this.closed = false;
            this.isStopped = false;
            this._parentOrParents = _parentOrParents;
            return this;
        };
        return Subscriber;
    }(Subscription));
    var SafeSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SafeSubscriber, _super);
        function SafeSubscriber(_parentSubscriber, observerOrNext, error, complete) {
            var _this = _super.call(this) || this;
            _this._parentSubscriber = _parentSubscriber;
            var next;
            var context = _this;
            if (isFunction(observerOrNext)) {
                next = observerOrNext;
            }
            else if (observerOrNext) {
                next = observerOrNext.next;
                error = observerOrNext.error;
                complete = observerOrNext.complete;
                if (observerOrNext !== empty$1) {
                    context = Object.create(observerOrNext);
                    if (isFunction(context.unsubscribe)) {
                        _this.add(context.unsubscribe.bind(context));
                    }
                    context.unsubscribe = _this.unsubscribe.bind(_this);
                }
            }
            _this._context = context;
            _this._next = next;
            _this._error = error;
            _this._complete = complete;
            return _this;
        }
        SafeSubscriber.prototype.next = function (value) {
            if (!this.isStopped && this._next) {
                var _parentSubscriber = this._parentSubscriber;
                if (!config.useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                    this.__tryOrUnsub(this._next, value);
                }
                else if (this.__tryOrSetError(_parentSubscriber, this._next, value)) {
                    this.unsubscribe();
                }
            }
        };
        SafeSubscriber.prototype.error = function (err) {
            if (!this.isStopped) {
                var _parentSubscriber = this._parentSubscriber;
                var useDeprecatedSynchronousErrorHandling = config.useDeprecatedSynchronousErrorHandling;
                if (this._error) {
                    if (!useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                        this.__tryOrUnsub(this._error, err);
                        this.unsubscribe();
                    }
                    else {
                        this.__tryOrSetError(_parentSubscriber, this._error, err);
                        this.unsubscribe();
                    }
                }
                else if (!_parentSubscriber.syncErrorThrowable) {
                    this.unsubscribe();
                    if (useDeprecatedSynchronousErrorHandling) {
                        throw err;
                    }
                    hostReportError(err);
                }
                else {
                    if (useDeprecatedSynchronousErrorHandling) {
                        _parentSubscriber.syncErrorValue = err;
                        _parentSubscriber.syncErrorThrown = true;
                    }
                    else {
                        hostReportError(err);
                    }
                    this.unsubscribe();
                }
            }
        };
        SafeSubscriber.prototype.complete = function () {
            var _this = this;
            if (!this.isStopped) {
                var _parentSubscriber = this._parentSubscriber;
                if (this._complete) {
                    var wrappedComplete = function () { return _this._complete.call(_this._context); };
                    if (!config.useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                        this.__tryOrUnsub(wrappedComplete);
                        this.unsubscribe();
                    }
                    else {
                        this.__tryOrSetError(_parentSubscriber, wrappedComplete);
                        this.unsubscribe();
                    }
                }
                else {
                    this.unsubscribe();
                }
            }
        };
        SafeSubscriber.prototype.__tryOrUnsub = function (fn, value) {
            try {
                fn.call(this._context, value);
            }
            catch (err) {
                this.unsubscribe();
                if (config.useDeprecatedSynchronousErrorHandling) {
                    throw err;
                }
                else {
                    hostReportError(err);
                }
            }
        };
        SafeSubscriber.prototype.__tryOrSetError = function (parent, fn, value) {
            if (!config.useDeprecatedSynchronousErrorHandling) {
                throw new Error('bad call');
            }
            try {
                fn.call(this._context, value);
            }
            catch (err) {
                if (config.useDeprecatedSynchronousErrorHandling) {
                    parent.syncErrorValue = err;
                    parent.syncErrorThrown = true;
                    return true;
                }
                else {
                    hostReportError(err);
                    return true;
                }
            }
            return false;
        };
        SafeSubscriber.prototype._unsubscribe = function () {
            var _parentSubscriber = this._parentSubscriber;
            this._context = null;
            this._parentSubscriber = null;
            _parentSubscriber.unsubscribe();
        };
        return SafeSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START _Subscriber PURE_IMPORTS_END */
    function canReportError(observer) {
        while (observer) {
            var _a = observer, closed_1 = _a.closed, destination = _a.destination, isStopped = _a.isStopped;
            if (closed_1 || isStopped) {
                return false;
            }
            else if (destination && destination instanceof Subscriber) {
                observer = destination;
            }
            else {
                observer = null;
            }
        }
        return true;
    }

    /** PURE_IMPORTS_START _Subscriber,_symbol_rxSubscriber,_Observer PURE_IMPORTS_END */
    function toSubscriber(nextOrObserver, error, complete) {
        if (nextOrObserver) {
            if (nextOrObserver instanceof Subscriber) {
                return nextOrObserver;
            }
            if (nextOrObserver[rxSubscriber]) {
                return nextOrObserver[rxSubscriber]();
            }
        }
        if (!nextOrObserver && !error && !complete) {
            return new Subscriber(empty$1);
        }
        return new Subscriber(nextOrObserver, error, complete);
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var observable = /*@__PURE__*/ (function () { return typeof Symbol === 'function' && Symbol.observable || '@@observable'; })();

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function identity(x) {
        return x;
    }

    /** PURE_IMPORTS_START _identity PURE_IMPORTS_END */
    function pipeFromArray(fns) {
        if (fns.length === 0) {
            return identity;
        }
        if (fns.length === 1) {
            return fns[0];
        }
        return function piped(input) {
            return fns.reduce(function (prev, fn) { return fn(prev); }, input);
        };
    }

    /** PURE_IMPORTS_START _util_canReportError,_util_toSubscriber,_symbol_observable,_util_pipe,_config PURE_IMPORTS_END */
    var Observable = /*@__PURE__*/ (function () {
        function Observable(subscribe) {
            this._isScalar = false;
            if (subscribe) {
                this._subscribe = subscribe;
            }
        }
        Observable.prototype.lift = function (operator) {
            var observable = new Observable();
            observable.source = this;
            observable.operator = operator;
            return observable;
        };
        Observable.prototype.subscribe = function (observerOrNext, error, complete) {
            var operator = this.operator;
            var sink = toSubscriber(observerOrNext, error, complete);
            if (operator) {
                sink.add(operator.call(sink, this.source));
            }
            else {
                sink.add(this.source || (config.useDeprecatedSynchronousErrorHandling && !sink.syncErrorThrowable) ?
                    this._subscribe(sink) :
                    this._trySubscribe(sink));
            }
            if (config.useDeprecatedSynchronousErrorHandling) {
                if (sink.syncErrorThrowable) {
                    sink.syncErrorThrowable = false;
                    if (sink.syncErrorThrown) {
                        throw sink.syncErrorValue;
                    }
                }
            }
            return sink;
        };
        Observable.prototype._trySubscribe = function (sink) {
            try {
                return this._subscribe(sink);
            }
            catch (err) {
                if (config.useDeprecatedSynchronousErrorHandling) {
                    sink.syncErrorThrown = true;
                    sink.syncErrorValue = err;
                }
                if (canReportError(sink)) {
                    sink.error(err);
                }
                else {
                    console.warn(err);
                }
            }
        };
        Observable.prototype.forEach = function (next, promiseCtor) {
            var _this = this;
            promiseCtor = getPromiseCtor(promiseCtor);
            return new promiseCtor(function (resolve, reject) {
                var subscription;
                subscription = _this.subscribe(function (value) {
                    try {
                        next(value);
                    }
                    catch (err) {
                        reject(err);
                        if (subscription) {
                            subscription.unsubscribe();
                        }
                    }
                }, reject, resolve);
            });
        };
        Observable.prototype._subscribe = function (subscriber) {
            var source = this.source;
            return source && source.subscribe(subscriber);
        };
        Observable.prototype[observable] = function () {
            return this;
        };
        Observable.prototype.pipe = function () {
            var operations = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                operations[_i] = arguments[_i];
            }
            if (operations.length === 0) {
                return this;
            }
            return pipeFromArray(operations)(this);
        };
        Observable.prototype.toPromise = function (promiseCtor) {
            var _this = this;
            promiseCtor = getPromiseCtor(promiseCtor);
            return new promiseCtor(function (resolve, reject) {
                var value;
                _this.subscribe(function (x) { return value = x; }, function (err) { return reject(err); }, function () { return resolve(value); });
            });
        };
        Observable.create = function (subscribe) {
            return new Observable(subscribe);
        };
        return Observable;
    }());
    function getPromiseCtor(promiseCtor) {
        if (!promiseCtor) {
            promiseCtor = config.Promise || Promise;
        }
        if (!promiseCtor) {
            throw new Error('no Promise impl found');
        }
        return promiseCtor;
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var subscribeToArray = function (array) {
        return function (subscriber) {
            for (var i = 0, len = array.length; i < len && !subscriber.closed; i++) {
                subscriber.next(array[i]);
            }
            subscriber.complete();
        };
    };

    /** PURE_IMPORTS_START _hostReportError PURE_IMPORTS_END */
    var subscribeToPromise = function (promise) {
        return function (subscriber) {
            promise.then(function (value) {
                if (!subscriber.closed) {
                    subscriber.next(value);
                    subscriber.complete();
                }
            }, function (err) { return subscriber.error(err); })
                .then(null, hostReportError);
            return subscriber;
        };
    };

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function getSymbolIterator() {
        if (typeof Symbol !== 'function' || !Symbol.iterator) {
            return '@@iterator';
        }
        return Symbol.iterator;
    }
    var iterator = /*@__PURE__*/ getSymbolIterator();

    /** PURE_IMPORTS_START _symbol_iterator PURE_IMPORTS_END */
    var subscribeToIterable = function (iterable) {
        return function (subscriber) {
            var iterator$1 = iterable[iterator]();
            do {
                var item = void 0;
                try {
                    item = iterator$1.next();
                }
                catch (err) {
                    subscriber.error(err);
                    return subscriber;
                }
                if (item.done) {
                    subscriber.complete();
                    break;
                }
                subscriber.next(item.value);
                if (subscriber.closed) {
                    break;
                }
            } while (true);
            if (typeof iterator$1.return === 'function') {
                subscriber.add(function () {
                    if (iterator$1.return) {
                        iterator$1.return();
                    }
                });
            }
            return subscriber;
        };
    };

    /** PURE_IMPORTS_START _symbol_observable PURE_IMPORTS_END */
    var subscribeToObservable = function (obj) {
        return function (subscriber) {
            var obs = obj[observable]();
            if (typeof obs.subscribe !== 'function') {
                throw new TypeError('Provided object does not correctly implement Symbol.observable');
            }
            else {
                return obs.subscribe(subscriber);
            }
        };
    };

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var isArrayLike = (function (x) { return x && typeof x.length === 'number' && typeof x !== 'function'; });

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function isPromise(value) {
        return !!value && typeof value.subscribe !== 'function' && typeof value.then === 'function';
    }

    /** PURE_IMPORTS_START _subscribeToArray,_subscribeToPromise,_subscribeToIterable,_subscribeToObservable,_isArrayLike,_isPromise,_isObject,_symbol_iterator,_symbol_observable PURE_IMPORTS_END */
    var subscribeTo = function (result) {
        if (!!result && typeof result[observable] === 'function') {
            return subscribeToObservable(result);
        }
        else if (isArrayLike(result)) {
            return subscribeToArray(result);
        }
        else if (isPromise(result)) {
            return subscribeToPromise(result);
        }
        else if (!!result && typeof result[iterator] === 'function') {
            return subscribeToIterable(result);
        }
        else {
            var value = isObject(result) ? 'an invalid object' : "'" + result + "'";
            var msg = "You provided " + value + " where a stream was expected."
                + ' You can provide an Observable, Promise, Array, or Iterable.';
            throw new TypeError(msg);
        }
    };

    /** PURE_IMPORTS_START tslib,_Subscriber,_Observable,_util_subscribeTo PURE_IMPORTS_END */
    var SimpleInnerSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SimpleInnerSubscriber, _super);
        function SimpleInnerSubscriber(parent) {
            var _this = _super.call(this) || this;
            _this.parent = parent;
            return _this;
        }
        SimpleInnerSubscriber.prototype._next = function (value) {
            this.parent.notifyNext(value);
        };
        SimpleInnerSubscriber.prototype._error = function (error) {
            this.parent.notifyError(error);
            this.unsubscribe();
        };
        SimpleInnerSubscriber.prototype._complete = function () {
            this.parent.notifyComplete();
            this.unsubscribe();
        };
        return SimpleInnerSubscriber;
    }(Subscriber));
    var SimpleOuterSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SimpleOuterSubscriber, _super);
        function SimpleOuterSubscriber() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SimpleOuterSubscriber.prototype.notifyNext = function (innerValue) {
            this.destination.next(innerValue);
        };
        SimpleOuterSubscriber.prototype.notifyError = function (err) {
            this.destination.error(err);
        };
        SimpleOuterSubscriber.prototype.notifyComplete = function () {
            this.destination.complete();
        };
        return SimpleOuterSubscriber;
    }(Subscriber));
    function innerSubscribe(result, innerSubscriber) {
        if (innerSubscriber.closed) {
            return undefined;
        }
        if (result instanceof Observable) {
            return result.subscribe(innerSubscriber);
        }
        var subscription;
        try {
            subscription = subscribeTo(result)(innerSubscriber);
        }
        catch (error) {
            innerSubscriber.error(error);
        }
        return subscription;
    }

    /** PURE_IMPORTS_START tslib,_Subscription PURE_IMPORTS_END */
    var Action = /*@__PURE__*/ (function (_super) {
        __extends(Action, _super);
        function Action(scheduler, work) {
            return _super.call(this) || this;
        }
        Action.prototype.schedule = function (state, delay) {
            return this;
        };
        return Action;
    }(Subscription));

    /** PURE_IMPORTS_START tslib,_Action PURE_IMPORTS_END */
    var AsyncAction = /*@__PURE__*/ (function (_super) {
        __extends(AsyncAction, _super);
        function AsyncAction(scheduler, work) {
            var _this = _super.call(this, scheduler, work) || this;
            _this.scheduler = scheduler;
            _this.work = work;
            _this.pending = false;
            return _this;
        }
        AsyncAction.prototype.schedule = function (state, delay) {
            if (delay === void 0) {
                delay = 0;
            }
            if (this.closed) {
                return this;
            }
            this.state = state;
            var id = this.id;
            var scheduler = this.scheduler;
            if (id != null) {
                this.id = this.recycleAsyncId(scheduler, id, delay);
            }
            this.pending = true;
            this.delay = delay;
            this.id = this.id || this.requestAsyncId(scheduler, this.id, delay);
            return this;
        };
        AsyncAction.prototype.requestAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) {
                delay = 0;
            }
            return setInterval(scheduler.flush.bind(scheduler, this), delay);
        };
        AsyncAction.prototype.recycleAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) {
                delay = 0;
            }
            if (delay !== null && this.delay === delay && this.pending === false) {
                return id;
            }
            clearInterval(id);
            return undefined;
        };
        AsyncAction.prototype.execute = function (state, delay) {
            if (this.closed) {
                return new Error('executing a cancelled action');
            }
            this.pending = false;
            var error = this._execute(state, delay);
            if (error) {
                return error;
            }
            else if (this.pending === false && this.id != null) {
                this.id = this.recycleAsyncId(this.scheduler, this.id, null);
            }
        };
        AsyncAction.prototype._execute = function (state, delay) {
            var errored = false;
            var errorValue = undefined;
            try {
                this.work(state);
            }
            catch (e) {
                errored = true;
                errorValue = !!e && e || new Error(e);
            }
            if (errored) {
                this.unsubscribe();
                return errorValue;
            }
        };
        AsyncAction.prototype._unsubscribe = function () {
            var id = this.id;
            var scheduler = this.scheduler;
            var actions = scheduler.actions;
            var index = actions.indexOf(this);
            this.work = null;
            this.state = null;
            this.pending = false;
            this.scheduler = null;
            if (index !== -1) {
                actions.splice(index, 1);
            }
            if (id != null) {
                this.id = this.recycleAsyncId(scheduler, id, null);
            }
            this.delay = null;
        };
        return AsyncAction;
    }(Action));

    var Scheduler = /*@__PURE__*/ (function () {
        function Scheduler(SchedulerAction, now) {
            if (now === void 0) {
                now = Scheduler.now;
            }
            this.SchedulerAction = SchedulerAction;
            this.now = now;
        }
        Scheduler.prototype.schedule = function (work, delay, state) {
            if (delay === void 0) {
                delay = 0;
            }
            return new this.SchedulerAction(this, work).schedule(state, delay);
        };
        Scheduler.now = function () { return Date.now(); };
        return Scheduler;
    }());

    /** PURE_IMPORTS_START tslib,_Scheduler PURE_IMPORTS_END */
    var AsyncScheduler = /*@__PURE__*/ (function (_super) {
        __extends(AsyncScheduler, _super);
        function AsyncScheduler(SchedulerAction, now) {
            if (now === void 0) {
                now = Scheduler.now;
            }
            var _this = _super.call(this, SchedulerAction, function () {
                if (AsyncScheduler.delegate && AsyncScheduler.delegate !== _this) {
                    return AsyncScheduler.delegate.now();
                }
                else {
                    return now();
                }
            }) || this;
            _this.actions = [];
            _this.active = false;
            _this.scheduled = undefined;
            return _this;
        }
        AsyncScheduler.prototype.schedule = function (work, delay, state) {
            if (delay === void 0) {
                delay = 0;
            }
            if (AsyncScheduler.delegate && AsyncScheduler.delegate !== this) {
                return AsyncScheduler.delegate.schedule(work, delay, state);
            }
            else {
                return _super.prototype.schedule.call(this, work, delay, state);
            }
        };
        AsyncScheduler.prototype.flush = function (action) {
            var actions = this.actions;
            if (this.active) {
                actions.push(action);
                return;
            }
            var error;
            this.active = true;
            do {
                if (error = action.execute(action.state, action.delay)) {
                    break;
                }
            } while (action = actions.shift());
            this.active = false;
            if (error) {
                while (action = actions.shift()) {
                    action.unsubscribe();
                }
                throw error;
            }
        };
        return AsyncScheduler;
    }(Scheduler));

    /** PURE_IMPORTS_START _AsyncAction,_AsyncScheduler PURE_IMPORTS_END */
    var asyncScheduler = /*@__PURE__*/ new AsyncScheduler(AsyncAction);
    var async = asyncScheduler;

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function isScheduler(value) {
        return value && typeof value.schedule === 'function';
    }

    /** PURE_IMPORTS_START _Observable,_Subscription PURE_IMPORTS_END */
    function scheduleArray(input, scheduler) {
        return new Observable(function (subscriber) {
            var sub = new Subscription();
            var i = 0;
            sub.add(scheduler.schedule(function () {
                if (i === input.length) {
                    subscriber.complete();
                    return;
                }
                subscriber.next(input[i++]);
                if (!subscriber.closed) {
                    sub.add(this.schedule());
                }
            }));
            return sub;
        });
    }

    /** PURE_IMPORTS_START _Observable,_util_subscribeToArray,_scheduled_scheduleArray PURE_IMPORTS_END */
    function fromArray(input, scheduler) {
        if (!scheduler) {
            return new Observable(subscribeToArray(input));
        }
        else {
            return scheduleArray(input, scheduler);
        }
    }

    /** PURE_IMPORTS_START _Observable,_Subscription,_symbol_observable PURE_IMPORTS_END */
    function scheduleObservable(input, scheduler) {
        return new Observable(function (subscriber) {
            var sub = new Subscription();
            sub.add(scheduler.schedule(function () {
                var observable$1 = input[observable]();
                sub.add(observable$1.subscribe({
                    next: function (value) { sub.add(scheduler.schedule(function () { return subscriber.next(value); })); },
                    error: function (err) { sub.add(scheduler.schedule(function () { return subscriber.error(err); })); },
                    complete: function () { sub.add(scheduler.schedule(function () { return subscriber.complete(); })); },
                }));
            }));
            return sub;
        });
    }

    /** PURE_IMPORTS_START _Observable,_Subscription PURE_IMPORTS_END */
    function schedulePromise(input, scheduler) {
        return new Observable(function (subscriber) {
            var sub = new Subscription();
            sub.add(scheduler.schedule(function () {
                return input.then(function (value) {
                    sub.add(scheduler.schedule(function () {
                        subscriber.next(value);
                        sub.add(scheduler.schedule(function () { return subscriber.complete(); }));
                    }));
                }, function (err) {
                    sub.add(scheduler.schedule(function () { return subscriber.error(err); }));
                });
            }));
            return sub;
        });
    }

    /** PURE_IMPORTS_START _Observable,_Subscription,_symbol_iterator PURE_IMPORTS_END */
    function scheduleIterable(input, scheduler) {
        if (!input) {
            throw new Error('Iterable cannot be null');
        }
        return new Observable(function (subscriber) {
            var sub = new Subscription();
            var iterator$1;
            sub.add(function () {
                if (iterator$1 && typeof iterator$1.return === 'function') {
                    iterator$1.return();
                }
            });
            sub.add(scheduler.schedule(function () {
                iterator$1 = input[iterator]();
                sub.add(scheduler.schedule(function () {
                    if (subscriber.closed) {
                        return;
                    }
                    var value;
                    var done;
                    try {
                        var result = iterator$1.next();
                        value = result.value;
                        done = result.done;
                    }
                    catch (err) {
                        subscriber.error(err);
                        return;
                    }
                    if (done) {
                        subscriber.complete();
                    }
                    else {
                        subscriber.next(value);
                        this.schedule();
                    }
                }));
            }));
            return sub;
        });
    }

    /** PURE_IMPORTS_START _symbol_observable PURE_IMPORTS_END */
    function isInteropObservable(input) {
        return input && typeof input[observable] === 'function';
    }

    /** PURE_IMPORTS_START _symbol_iterator PURE_IMPORTS_END */
    function isIterable(input) {
        return input && typeof input[iterator] === 'function';
    }

    /** PURE_IMPORTS_START _scheduleObservable,_schedulePromise,_scheduleArray,_scheduleIterable,_util_isInteropObservable,_util_isPromise,_util_isArrayLike,_util_isIterable PURE_IMPORTS_END */
    function scheduled(input, scheduler) {
        if (input != null) {
            if (isInteropObservable(input)) {
                return scheduleObservable(input, scheduler);
            }
            else if (isPromise(input)) {
                return schedulePromise(input, scheduler);
            }
            else if (isArrayLike(input)) {
                return scheduleArray(input, scheduler);
            }
            else if (isIterable(input) || typeof input === 'string') {
                return scheduleIterable(input, scheduler);
            }
        }
        throw new TypeError((input !== null && typeof input || input) + ' is not observable');
    }

    /** PURE_IMPORTS_START _Observable,_util_subscribeTo,_scheduled_scheduled PURE_IMPORTS_END */
    function from(input, scheduler) {
        if (!scheduler) {
            if (input instanceof Observable) {
                return input;
            }
            return new Observable(subscribeTo(input));
        }
        else {
            return scheduled(input, scheduler);
        }
    }

    /** PURE_IMPORTS_START _util_isScheduler,_fromArray,_scheduled_scheduleArray PURE_IMPORTS_END */
    function of() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var scheduler = args[args.length - 1];
        if (isScheduler(scheduler)) {
            args.pop();
            return scheduleArray(args, scheduler);
        }
        else {
            return fromArray(args);
        }
    }

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    function map(project, thisArg) {
        return function mapOperation(source) {
            if (typeof project !== 'function') {
                throw new TypeError('argument is not a function. Are you looking for `mapTo()`?');
            }
            return source.lift(new MapOperator(project, thisArg));
        };
    }
    var MapOperator = /*@__PURE__*/ (function () {
        function MapOperator(project, thisArg) {
            this.project = project;
            this.thisArg = thisArg;
        }
        MapOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new MapSubscriber(subscriber, this.project, this.thisArg));
        };
        return MapOperator;
    }());
    var MapSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(MapSubscriber, _super);
        function MapSubscriber(destination, project, thisArg) {
            var _this = _super.call(this, destination) || this;
            _this.project = project;
            _this.count = 0;
            _this.thisArg = thisArg || _this;
            return _this;
        }
        MapSubscriber.prototype._next = function (value) {
            var result;
            try {
                result = this.project.call(this.thisArg, value, this.count++);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.next(result);
        };
        return MapSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_map,_observable_from,_innerSubscribe PURE_IMPORTS_END */
    function mergeMap(project, resultSelector, concurrent) {
        if (concurrent === void 0) {
            concurrent = Number.POSITIVE_INFINITY;
        }
        if (typeof resultSelector === 'function') {
            return function (source) { return source.pipe(mergeMap(function (a, i) { return from(project(a, i)).pipe(map(function (b, ii) { return resultSelector(a, b, i, ii); })); }, concurrent)); };
        }
        else if (typeof resultSelector === 'number') {
            concurrent = resultSelector;
        }
        return function (source) { return source.lift(new MergeMapOperator(project, concurrent)); };
    }
    var MergeMapOperator = /*@__PURE__*/ (function () {
        function MergeMapOperator(project, concurrent) {
            if (concurrent === void 0) {
                concurrent = Number.POSITIVE_INFINITY;
            }
            this.project = project;
            this.concurrent = concurrent;
        }
        MergeMapOperator.prototype.call = function (observer, source) {
            return source.subscribe(new MergeMapSubscriber(observer, this.project, this.concurrent));
        };
        return MergeMapOperator;
    }());
    var MergeMapSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(MergeMapSubscriber, _super);
        function MergeMapSubscriber(destination, project, concurrent) {
            if (concurrent === void 0) {
                concurrent = Number.POSITIVE_INFINITY;
            }
            var _this = _super.call(this, destination) || this;
            _this.project = project;
            _this.concurrent = concurrent;
            _this.hasCompleted = false;
            _this.buffer = [];
            _this.active = 0;
            _this.index = 0;
            return _this;
        }
        MergeMapSubscriber.prototype._next = function (value) {
            if (this.active < this.concurrent) {
                this._tryNext(value);
            }
            else {
                this.buffer.push(value);
            }
        };
        MergeMapSubscriber.prototype._tryNext = function (value) {
            var result;
            var index = this.index++;
            try {
                result = this.project(value, index);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.active++;
            this._innerSub(result);
        };
        MergeMapSubscriber.prototype._innerSub = function (ish) {
            var innerSubscriber = new SimpleInnerSubscriber(this);
            var destination = this.destination;
            destination.add(innerSubscriber);
            var innerSubscription = innerSubscribe(ish, innerSubscriber);
            if (innerSubscription !== innerSubscriber) {
                destination.add(innerSubscription);
            }
        };
        MergeMapSubscriber.prototype._complete = function () {
            this.hasCompleted = true;
            if (this.active === 0 && this.buffer.length === 0) {
                this.destination.complete();
            }
            this.unsubscribe();
        };
        MergeMapSubscriber.prototype.notifyNext = function (innerValue) {
            this.destination.next(innerValue);
        };
        MergeMapSubscriber.prototype.notifyComplete = function () {
            var buffer = this.buffer;
            this.active--;
            if (buffer.length > 0) {
                this._next(buffer.shift());
            }
            else if (this.active === 0 && this.hasCompleted) {
                this.destination.complete();
            }
        };
        return MergeMapSubscriber;
    }(SimpleOuterSubscriber));

    /** PURE_IMPORTS_START _mergeMap,_util_identity PURE_IMPORTS_END */
    function mergeAll(concurrent) {
        if (concurrent === void 0) {
            concurrent = Number.POSITIVE_INFINITY;
        }
        return mergeMap(identity, concurrent);
    }

    /** PURE_IMPORTS_START _mergeAll PURE_IMPORTS_END */
    function concatAll() {
        return mergeAll(1);
    }

    /** PURE_IMPORTS_START _of,_operators_concatAll PURE_IMPORTS_END */
    function concat() {
        var observables = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            observables[_i] = arguments[_i];
        }
        return concatAll()(of.apply(void 0, observables));
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function isDate(value) {
        return value instanceof Date && !isNaN(+value);
    }

    /** PURE_IMPORTS_START _Observable PURE_IMPORTS_END */
    var EMPTY = /*@__PURE__*/ new Observable(function (subscriber) { return subscriber.complete(); });
    function empty(scheduler) {
        return scheduler ? emptyScheduled(scheduler) : EMPTY;
    }
    function emptyScheduled(scheduler) {
        return new Observable(function (subscriber) { return scheduler.schedule(function () { return subscriber.complete(); }); });
    }

    /** PURE_IMPORTS_START _Observable PURE_IMPORTS_END */
    function throwError(error, scheduler) {
        if (!scheduler) {
            return new Observable(function (subscriber) { return subscriber.error(error); });
        }
        else {
            return new Observable(function (subscriber) { return scheduler.schedule(dispatch, 0, { error: error, subscriber: subscriber }); });
        }
    }
    function dispatch(_a) {
        var error = _a.error, subscriber = _a.subscriber;
        subscriber.error(error);
    }

    /** PURE_IMPORTS_START _observable_empty,_observable_of,_observable_throwError PURE_IMPORTS_END */
    var Notification = /*@__PURE__*/ (function () {
        function Notification(kind, value, error) {
            this.kind = kind;
            this.value = value;
            this.error = error;
            this.hasValue = kind === 'N';
        }
        Notification.prototype.observe = function (observer) {
            switch (this.kind) {
                case 'N':
                    return observer.next && observer.next(this.value);
                case 'E':
                    return observer.error && observer.error(this.error);
                case 'C':
                    return observer.complete && observer.complete();
            }
        };
        Notification.prototype.do = function (next, error, complete) {
            var kind = this.kind;
            switch (kind) {
                case 'N':
                    return next && next(this.value);
                case 'E':
                    return error && error(this.error);
                case 'C':
                    return complete && complete();
            }
        };
        Notification.prototype.accept = function (nextOrObserver, error, complete) {
            if (nextOrObserver && typeof nextOrObserver.next === 'function') {
                return this.observe(nextOrObserver);
            }
            else {
                return this.do(nextOrObserver, error, complete);
            }
        };
        Notification.prototype.toObservable = function () {
            var kind = this.kind;
            switch (kind) {
                case 'N':
                    return of(this.value);
                case 'E':
                    return throwError(this.error);
                case 'C':
                    return empty();
            }
            throw new Error('unexpected notification kind value');
        };
        Notification.createNext = function (value) {
            if (typeof value !== 'undefined') {
                return new Notification('N', value);
            }
            return Notification.undefinedValueNotification;
        };
        Notification.createError = function (err) {
            return new Notification('E', undefined, err);
        };
        Notification.createComplete = function () {
            return Notification.completeNotification;
        };
        Notification.completeNotification = new Notification('C');
        Notification.undefinedValueNotification = new Notification('N', undefined);
        return Notification;
    }());

    /** PURE_IMPORTS_START tslib,_scheduler_async,_util_isDate,_Subscriber,_Notification PURE_IMPORTS_END */
    function delay(delay, scheduler) {
        if (scheduler === void 0) {
            scheduler = async;
        }
        var absoluteDelay = isDate(delay);
        var delayFor = absoluteDelay ? (+delay - scheduler.now()) : Math.abs(delay);
        return function (source) { return source.lift(new DelayOperator(delayFor, scheduler)); };
    }
    var DelayOperator = /*@__PURE__*/ (function () {
        function DelayOperator(delay, scheduler) {
            this.delay = delay;
            this.scheduler = scheduler;
        }
        DelayOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new DelaySubscriber(subscriber, this.delay, this.scheduler));
        };
        return DelayOperator;
    }());
    var DelaySubscriber = /*@__PURE__*/ (function (_super) {
        __extends(DelaySubscriber, _super);
        function DelaySubscriber(destination, delay, scheduler) {
            var _this = _super.call(this, destination) || this;
            _this.delay = delay;
            _this.scheduler = scheduler;
            _this.queue = [];
            _this.active = false;
            _this.errored = false;
            return _this;
        }
        DelaySubscriber.dispatch = function (state) {
            var source = state.source;
            var queue = source.queue;
            var scheduler = state.scheduler;
            var destination = state.destination;
            while (queue.length > 0 && (queue[0].time - scheduler.now()) <= 0) {
                queue.shift().notification.observe(destination);
            }
            if (queue.length > 0) {
                var delay_1 = Math.max(0, queue[0].time - scheduler.now());
                this.schedule(state, delay_1);
            }
            else {
                this.unsubscribe();
                source.active = false;
            }
        };
        DelaySubscriber.prototype._schedule = function (scheduler) {
            this.active = true;
            var destination = this.destination;
            destination.add(scheduler.schedule(DelaySubscriber.dispatch, this.delay, {
                source: this, destination: this.destination, scheduler: scheduler
            }));
        };
        DelaySubscriber.prototype.scheduleNotification = function (notification) {
            if (this.errored === true) {
                return;
            }
            var scheduler = this.scheduler;
            var message = new DelayMessage(scheduler.now() + this.delay, notification);
            this.queue.push(message);
            if (this.active === false) {
                this._schedule(scheduler);
            }
        };
        DelaySubscriber.prototype._next = function (value) {
            this.scheduleNotification(Notification.createNext(value));
        };
        DelaySubscriber.prototype._error = function (err) {
            this.errored = true;
            this.queue = [];
            this.destination.error(err);
            this.unsubscribe();
        };
        DelaySubscriber.prototype._complete = function () {
            this.scheduleNotification(Notification.createComplete());
            this.unsubscribe();
        };
        return DelaySubscriber;
    }(Subscriber));
    var DelayMessage = /*@__PURE__*/ (function () {
        function DelayMessage(time, notification) {
            this.time = time;
            this.notification = notification;
        }
        return DelayMessage;
    }());

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    function filter(predicate, thisArg) {
        return function filterOperatorFunction(source) {
            return source.lift(new FilterOperator(predicate, thisArg));
        };
    }
    var FilterOperator = /*@__PURE__*/ (function () {
        function FilterOperator(predicate, thisArg) {
            this.predicate = predicate;
            this.thisArg = thisArg;
        }
        FilterOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new FilterSubscriber(subscriber, this.predicate, this.thisArg));
        };
        return FilterOperator;
    }());
    var FilterSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(FilterSubscriber, _super);
        function FilterSubscriber(destination, predicate, thisArg) {
            var _this = _super.call(this, destination) || this;
            _this.predicate = predicate;
            _this.thisArg = thisArg;
            _this.count = 0;
            return _this;
        }
        FilterSubscriber.prototype._next = function (value) {
            var result;
            try {
                result = this.predicate.call(this.thisArg, value, this.count++);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            if (result) {
                this.destination.next(value);
            }
        };
        return FilterSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START _observable_concat,_util_isScheduler PURE_IMPORTS_END */
    function startWith() {
        var array = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            array[_i] = arguments[_i];
        }
        var scheduler = array[array.length - 1];
        if (isScheduler(scheduler)) {
            array.pop();
            return function (source) { return concat(array, source, scheduler); };
        }
        else {
            return function (source) { return concat(array, source); };
        }
    }

    /** PURE_IMPORTS_START tslib,_innerSubscribe PURE_IMPORTS_END */
    function takeUntil(notifier) {
        return function (source) { return source.lift(new TakeUntilOperator(notifier)); };
    }
    var TakeUntilOperator = /*@__PURE__*/ (function () {
        function TakeUntilOperator(notifier) {
            this.notifier = notifier;
        }
        TakeUntilOperator.prototype.call = function (subscriber, source) {
            var takeUntilSubscriber = new TakeUntilSubscriber(subscriber);
            var notifierSubscription = innerSubscribe(this.notifier, new SimpleInnerSubscriber(takeUntilSubscriber));
            if (notifierSubscription && !takeUntilSubscriber.seenValue) {
                takeUntilSubscriber.add(notifierSubscription);
                return source.subscribe(takeUntilSubscriber);
            }
            return takeUntilSubscriber;
        };
        return TakeUntilOperator;
    }());
    var TakeUntilSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(TakeUntilSubscriber, _super);
        function TakeUntilSubscriber(destination) {
            var _this = _super.call(this, destination) || this;
            _this.seenValue = false;
            return _this;
        }
        TakeUntilSubscriber.prototype.notifyNext = function () {
            this.seenValue = true;
            this.complete();
        };
        TakeUntilSubscriber.prototype.notifyComplete = function () {
        };
        return TakeUntilSubscriber;
    }(SimpleOuterSubscriber));

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function noop() { }

    /** PURE_IMPORTS_START tslib,_Subscriber,_util_noop,_util_isFunction PURE_IMPORTS_END */
    function tap(nextOrObserver, error, complete) {
        return function tapOperatorFunction(source) {
            return source.lift(new DoOperator(nextOrObserver, error, complete));
        };
    }
    var DoOperator = /*@__PURE__*/ (function () {
        function DoOperator(nextOrObserver, error, complete) {
            this.nextOrObserver = nextOrObserver;
            this.error = error;
            this.complete = complete;
        }
        DoOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new TapSubscriber(subscriber, this.nextOrObserver, this.error, this.complete));
        };
        return DoOperator;
    }());
    var TapSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(TapSubscriber, _super);
        function TapSubscriber(destination, observerOrNext, error, complete) {
            var _this = _super.call(this, destination) || this;
            _this._tapNext = noop;
            _this._tapError = noop;
            _this._tapComplete = noop;
            _this._tapError = error || noop;
            _this._tapComplete = complete || noop;
            if (isFunction(observerOrNext)) {
                _this._context = _this;
                _this._tapNext = observerOrNext;
            }
            else if (observerOrNext) {
                _this._context = observerOrNext;
                _this._tapNext = observerOrNext.next || noop;
                _this._tapError = observerOrNext.error || noop;
                _this._tapComplete = observerOrNext.complete || noop;
            }
            return _this;
        }
        TapSubscriber.prototype._next = function (value) {
            try {
                this._tapNext.call(this._context, value);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.next(value);
        };
        TapSubscriber.prototype._error = function (err) {
            try {
                this._tapError.call(this._context, err);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.error(err);
        };
        TapSubscriber.prototype._complete = function () {
            try {
                this._tapComplete.call(this._context);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            return this.destination.complete();
        };
        return TapSubscriber;
    }(Subscriber));

    class InputContainer extends React.PureComponent {
      constructor(props) {
        super(props);
        this.destroy$ = new rxjs.Subject();
        this.state = {
          status: "SUCCESS"
        };
        this.initializeControl.bind(this);
      }

      componentDidMount() {
        const control = this.props.control;
        control && this.initializeControl(control);
      }

      initializeControl(control) {
        control.statusChanges.pipe(takeUntil(this.destroy$), startWith(control.status), map(statusType => {
          if (statusType === "INVALID") {
            return {
              status: "ERROR",
              error: control.errors
            };
          } else if (statusType === "PENDING") {
            return {
              status: "PROCESSING",
              data: {}
            };
          }

          return {
            status: "SUCCESS",
            data: {}
          };
        }), tap(execution => {
          this.setState({
            data: execution.data,
            error: execution.error,
            status: execution.status
          });
        })).subscribe();
      }

      componentDidUpdate(prevProps) {
        let newControl = this.props.control;

        if (newControl && prevProps.control !== newControl) {
          this.initializeControl(newControl);
        }
      }

      componentWillUnmount() {
        this.destroy$.next();
        this.destroy$.complete();
      }

      render() {
        const control = this.props.control;
        const showErrorsFn = this.props.showErrorsFn ? this.props.showErrorsFn : () => true;
        const formLoadStatus = this.props.formLoadStatus ? this.props.formLoadStatus : "SUCCESS";
        const showErrors = control ? showErrorsFn(control) : false;
        const data = this.props.data ? this.props.data : {};
        const dataLoadStatus = data.load ? data.load : {
          status: "SUCCESS"
        };
        const renderLabel = this.props.renderLabel;
        const labelTemplate = renderLabel && renderLabel({
          showErrors,
          validationStatus: this.state.status
        });
        const renderInput = this.props.renderInput;
        const inputTemplate = control && formLoadStatus === "SUCCESS" && dataLoadStatus.status === "SUCCESS" && renderInput({
          control,
          data: dataLoadStatus.data,
          validationStatus: this.state.status,
          showErrors
        });
        const renderProcessing = this.props.renderProcessing;
        const processingTemplate = (formLoadStatus === "PROCESSING" || dataLoadStatus.status === "PROCESSING") && renderProcessing && renderProcessing();
        const renderValidationErrors = this.props.renderValidationErrors;
        const validationErrorsTemplate = control && formLoadStatus === "SUCCESS" && dataLoadStatus.status === "SUCCESS" && showErrors && renderValidationErrors && renderValidationErrors({
          errors: this.state.error,
          control
        });
        const renderReload = data.renderReload;
        const reloadTemplate = dataLoadStatus.status === "ERROR" && renderReload && renderReload(dataLoadStatus.error);
        return /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, formLoadStatus !== "ERROR" && /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, labelTemplate, inputTemplate, processingTemplate, validationErrorsTemplate, reloadTemplate), formLoadStatus === "SUCCESS" && dataLoadStatus.status === "SUCCESS" && !this.props.control && /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null));
      }

    }

    const PrettyJson = props => {
      return /*#__PURE__*/React__default["default"].createElement("div", null, /*#__PURE__*/React__default["default"].createElement("pre", null, JSON.stringify(props.data, null, 2)));
    };

    function _extends() {
      _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];

          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }

        return target;
      };

      return _extends.apply(this, arguments);
    }

    class EventEmitter_ extends rxjs.Subject {
      // tslint:disable-line
      constructor(isAsync = false) {
        super();
        this.__isAsync = void 0;
        this.__isAsync = isAsync;
      }

      emit(value) {
        super.next(value);
      }

      subscribe(observerOrNext, error, complete) {
        let nextFn = observerOrNext;

        let errorFn = error || (() => null);

        let completeFn = complete;

        if (observerOrNext && typeof observerOrNext === "object") {
          var _observer$next, _observer$error, _observer$complete;

          const observer = observerOrNext;
          nextFn = (_observer$next = observer.next) == null ? void 0 : _observer$next.bind(observer);
          errorFn = (_observer$error = observer.error) == null ? void 0 : _observer$error.bind(observer);
          completeFn = (_observer$complete = observer.complete) == null ? void 0 : _observer$complete.bind(observer);
        }

        if (this.__isAsync) {
          errorFn = _wrapInTimeout(errorFn);

          if (nextFn) {
            nextFn = _wrapInTimeout(nextFn);
          }

          if (completeFn) {
            completeFn = _wrapInTimeout(completeFn);
          }
        }

        const sink = super.subscribe({
          next: nextFn,
          error: errorFn,
          complete: completeFn
        });

        if (observerOrNext instanceof rxjs.Subscription) {
          observerOrNext.add(sink);
        }

        return sink;
      }

    }

    function _wrapInTimeout(fn) {
      return value => {
        setTimeout(fn, undefined, value);
      };
    }
    /**
     * @publicApi
     */


    const EventEmitter2 = EventEmitter_;

    function removeListItem(list, el) {
      const index = list.indexOf(el);
      if (index > -1) list.splice(index, 1);
    }

    let ModuleUtils;

    (function (_ModuleUtils) {
      function isPromise(obj) {
        return !!obj && typeof obj.then === "function";
      }

      _ModuleUtils.isPromise = isPromise;

      function isSubscribable(obj) {
        return !!obj && typeof obj.subscribe === "function";
      }

      _ModuleUtils.isSubscribable = isSubscribable;
      _ModuleUtils.isObservable = isSubscribable;
    })(ModuleUtils || (ModuleUtils = {}));

    function isEmptyInputValue(value) {
      return value == null || value.length === 0;
    }

    function hasValidLength(value) {
      return value != null && typeof value.length === "number";
    }

    const EMAIL_REGEXP = /^(?=.{1,254}$)(?=.{1,64}@)[a-zA-Z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-zA-Z0-9!#$%&'*+/=?^_`{|}~-]+)*@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/;
    class Validators {
      static min(min) {
        return minValidator(min);
      }

      static max(max) {
        return maxValidator(max);
      }

      static required(control) {
        return requiredValidator(control);
      }

      static requiredTrue(control) {
        return requiredTrueValidator(control);
      }

      static email(control) {
        return emailValidator(control);
      }

      static minLength(minLength) {
        return minLengthValidator(minLength);
      }

      static maxLength(maxLength) {
        return maxLengthValidator(maxLength);
      }

      static pattern(pattern) {
        return patternValidator(pattern);
      }

      static nullValidator(control) {
        return nullValidator();
      }

      static compose(validators) {
        return compose(validators);
      }

      static composeAsync(validators) {
        return composeAsync(validators);
      }

    }
    function minValidator(min) {
      return control => {
        if (isEmptyInputValue(control.value) || isEmptyInputValue(min)) {
          return null; // don't validate empty values to allow optional controls
        }

        const value = parseFloat(control.value);
        return !isNaN(value) && value < min ? {
          min: {
            min: min,
            actual: control.value
          }
        } : null;
      };
    }
    function maxValidator(max) {
      return control => {
        if (isEmptyInputValue(control.value) || isEmptyInputValue(max)) {
          return null; // don't validate empty values to allow optional controls
        }

        const value = parseFloat(control.value);
        return !isNaN(value) && value > max ? {
          max: {
            max: max,
            actual: control.value
          }
        } : null;
      };
    }
    function requiredValidator(control) {
      return isEmptyInputValue(control.value) ? {
        required: true
      } : null;
    }
    function requiredTrueValidator(control) {
      return control.value === true ? null : {
        required: true
      };
    }
    function emailValidator(control) {
      if (isEmptyInputValue(control.value)) {
        return null; // don't validate empty values to allow optional controls
      }

      return EMAIL_REGEXP.test(control.value) ? null : {
        email: true
      };
    }
    function minLengthValidator(minLength) {
      return control => {
        if (isEmptyInputValue(control.value) || !hasValidLength(control.value)) {
          // don't validate empty values to allow optional controls
          // don't validate values without `length` property
          return null;
        }

        return control.value.length < minLength ? {
          minlength: {
            requiredLength: minLength,
            actualLength: control.value.length
          }
        } : null;
      };
    }
    /**
     * Validator that requires the length of the control's value to be less than or equal
     * to the provided maximum length. See `Validators.maxLength` for additional information.
     */

    function maxLengthValidator(maxLength) {
      return control => {
        return hasValidLength(control.value) && control.value.length > maxLength ? {
          maxlength: {
            requiredLength: maxLength,
            actualLength: control.value.length
          }
        } : null;
      };
    }
    /**
     * Validator that requires the control's value to match a regex pattern.
     * See `Validators.pattern` for additional information.
     */

    function patternValidator(pattern) {
      if (!pattern) return nullValidator;
      let regex;
      let regexStr;

      if (typeof pattern === "string") {
        regexStr = "";
        if (pattern.charAt(0) !== "^") regexStr += "^";
        regexStr += pattern;
        if (pattern.charAt(pattern.length - 1) !== "$") regexStr += "$";
        regex = new RegExp(regexStr);
      } else {
        regexStr = pattern.toString();
        regex = pattern;
      }

      return control => {
        if (isEmptyInputValue(control.value)) {
          return null; // don't validate empty values to allow optional controls
        }

        const value = control.value;
        return regex.test(value) ? null : {
          pattern: {
            requiredPattern: regexStr,
            actualValue: value
          }
        };
      };
    }
    /**
     * Function that has `ValidatorFn` shape, but performs no operation.
     */

    function nullValidator(control) {
      return null;
    }

    function isPresent(o) {
      return o != null;
    }

    function toObservable(r) {
      const obs = ModuleUtils.isPromise(r) ? rxjs.from(r) : r;

      if (!ModuleUtils.isObservable(obs)
      /* && (typeof ngDevMode === 'undefined' || ngDevMode)*/
      ) {
        throw new Error(`Expected validator to return Promise or Observable.`);
      }

      return obs;
    }

    function mergeErrors(arrayOfErrors) {
      let res = {}; // Not using Array.reduce here due to a Chrome 80 bug
      // https://bugs.chromium.org/p/chromium/issues/detail?id=1049982

      arrayOfErrors.forEach(errors => {
        res = errors != null ? _extends({}, res, errors) : res;
      });
      return Object.keys(res).length === 0 ? null : res;
    }

    function executeValidators(control, validators) {
      return validators.map(validator => validator(control));
    }

    function isValidatorFn(validator) {
      return !validator.validate;
    }
    /**
     * Given the list of validators that may contain both functions as well as classes, return the list
     * of validator functions (convert validator classes into validator functions). This is needed to
     * have consistent structure in validators list before composing them.
     *
     * @param validators The set of validators that may contain validators both in plain function form
     *     as well as represented as a validator class.
     */


    function normalizeValidators(validators) {
      return validators.map(validator => {
        return isValidatorFn(validator) ? validator : c => validator.validate(c);
      });
    }
    /**
     * Merges synchronous validators into a single validator function.
     * See `Validators.compose` for additional information.
     */

    function compose(validators) {
      if (!validators) return null;
      const presentValidators = validators.filter(isPresent);
      if (presentValidators.length === 0) return null;
      return function (control) {
        return mergeErrors(executeValidators(control, presentValidators));
      };
    }
    /**
     * Accepts a list of validators of different possible shapes (`Validator` and `ValidatorFn`),
     * normalizes the list (converts everything to `ValidatorFn`) and merges them into a single
     * validator function.
     */


    function composeValidators(validators) {
      return validators != null ? compose(normalizeValidators(validators)) : null;
    }
    /**
     * Merges asynchronous validators into a single validator function.
     * See `Validators.composeAsync` for additional information.
     */

    function composeAsync(validators) {
      if (!validators) return null;
      const presentValidators = validators.filter(isPresent);
      if (presentValidators.length === 0) return null;
      return function (control) {
        const observables = executeValidators(control, presentValidators).map(toObservable);
        return rxjs.forkJoin(observables).pipe(map(mergeErrors));
      };
    }
    /**
     * Accepts a list of async validators of different possible shapes (`AsyncValidator` and
     * `AsyncValidatorFn`), normalizes the list (converts everything to `AsyncValidatorFn`) and merges
     * them into a single validator function.
     */


    function composeAsyncValidators(validators) {
      return validators != null ? composeAsync(normalizeValidators(validators)) : null;
    }
    /**
     * Merges raw control validators with a given directive validator and returns the combined list of
     * validators as an array.
     */

    function mergeValidators(controlValidators, dirValidator) {
      if (controlValidators === null) return [dirValidator];
      return Array.isArray(controlValidators) ? [...controlValidators, dirValidator] : [controlValidators, dirValidator];
    }
    /**
     * Retrieves the list of raw synchronous validators attached to a given control.
     */

    function getControlValidators(control) {
      return control._rawValidators;
    }
    /**
     * Retrieves the list of raw asynchronous validators attached to a given control.
     */

    function getControlAsyncValidators(control) {
      return control._rawAsyncValidators;
    }
    /**
     * Accepts a singleton validator, an array, or null, and returns an array type with the provided
     * validators.
     *
     * @param validators A validator, validators, or null.
     * @returns A validators array.
     */

    function makeValidatorsArray(validators) {
      if (!validators) return [];
      return Array.isArray(validators) ? validators : [validators];
    }
    /**
     * Determines whether a validator or validators array has a given validator.
     *
     * @param validators The validator or validators to compare against.
     * @param validator The validator to check.
     * @returns Whether the validator is present.
     */

    function hasValidator(validators, validator) {
      return Array.isArray(validators) ? validators.includes(validator) : validators === validator;
    }
    /**
     * Combines two arrays of validators into one. If duplicates are provided, only one will be added.
     *
     * @param validators The new validators.
     * @param currentValidators The base array of currrent validators.
     * @returns An array of validators.
     */

    function addValidators(validators, currentValidators) {
      const current = makeValidatorsArray(currentValidators);
      const validatorsToAdd = makeValidatorsArray(validators);
      validatorsToAdd.forEach(v => {
        // Note: if there are duplicate entries in the new validators array,
        // only the first one would be added to the current list of validarors.
        // Duplicate ones would be ignored since `hasValidator` would detect
        // the presence of a validator function and we update the current list in place.
        if (!hasValidator(current, v)) {
          current.push(v);
        }
      });
      return current;
    }
    function removeValidators(validators, currentValidators) {
      return makeValidatorsArray(currentValidators).filter(v => !hasValidator(validators, v));
    }

    const VALID = "VALID";
    const INVALID = "INVALID";
    const PENDING = "PENDING";
    const DISABLED = "DISABLED";

    function _find(control, path, delimiter) {
      if (path == null) return null;

      if (!Array.isArray(path)) {
        path = path.split(delimiter);
      }

      if (Array.isArray(path) && path.length === 0) return null;
      let controlToFind = control;
      path.forEach(name => {
        if (controlToFind instanceof FormGroup) {
          controlToFind = controlToFind.controls.hasOwnProperty(name) ? controlToFind.controls[name] : null;
        } else if (controlToFind instanceof FormArray) {
          controlToFind = controlToFind.at(name) || null;
        } else {
          controlToFind = null;
        }
      });
      return controlToFind;
    }

    function pickValidators(validatorOrOpts) {
      return (isOptionsObj(validatorOrOpts) ? validatorOrOpts.validators : validatorOrOpts) || null;
    }

    function coerceToValidator(validator) {
      return Array.isArray(validator) ? composeValidators(validator) : validator || null;
    }

    function pickAsyncValidators(asyncValidator, validatorOrOpts) {
      return (isOptionsObj(validatorOrOpts) ? validatorOrOpts.asyncValidators : asyncValidator) || null;
    }

    function coerceToAsyncValidator(asyncValidator) {
      return Array.isArray(asyncValidator) ? composeAsyncValidators(asyncValidator) : asyncValidator || null;
    }

    function isOptionsObj(validatorOrOpts) {
      return validatorOrOpts != null && !Array.isArray(validatorOrOpts) && typeof validatorOrOpts === "object";
    }

    class AbstractControl {
      constructor(validators, asyncValidators) {
        this._pendingDirty = void 0;
        this._hasOwnPendingAsyncValidator = false;
        this._pendingTouched = void 0;

        this._onCollectionChange = () => {};

        this._updateOn = void 0;
        this._parent = null;
        this._asyncValidationSubscription = void 0;
        this._composedValidatorFn = void 0;
        this._composedAsyncValidatorFn = void 0;
        this._rawValidators = void 0;
        this._rawAsyncValidators = void 0;
        this.value = void 0;
        this.status = void 0;
        this.errors = void 0;
        this.pristine = true;
        this.touched = false;
        this.valueChanges = void 0;
        this.statusChanges = void 0;
        this._onDisabledChange = [];
        this.reRender = void 0;
        this._rawValidators = validators;
        this._rawAsyncValidators = asyncValidators;
        this._composedValidatorFn = coerceToValidator(this._rawValidators);
        this._composedAsyncValidatorFn = coerceToAsyncValidator(this._rawAsyncValidators);
      }

      get validator() {
        return this._composedValidatorFn;
      }

      set validator(validatorFn) {
        this._rawValidators = this._composedValidatorFn = validatorFn;
      }

      get asyncValidator() {
        return this._composedAsyncValidatorFn;
      }

      set asyncValidator(asyncValidatorFn) {
        this._rawAsyncValidators = this._composedAsyncValidatorFn = asyncValidatorFn;
      }

      get parent() {
        return this._parent;
      }

      get valid() {
        return this.status === VALID;
      }

      get invalid() {
        return this.status === INVALID;
      }

      get pending() {
        return this.status === PENDING;
      }

      get disabled() {
        return this.status === DISABLED;
      }

      get enabled() {
        return this.status !== DISABLED;
      }

      get dirty() {
        return !this.pristine;
      }

      get untouched() {
        return !this.touched;
      }

      get updateOn() {
        return this._updateOn ? this._updateOn : this.parent ? this.parent.updateOn : "change";
      }

      setValidators(validators) {
        this._rawValidators = validators;
        this._composedValidatorFn = coerceToValidator(validators);
      }

      setAsyncValidators(validators) {
        this._rawAsyncValidators = validators;
        this._composedAsyncValidatorFn = coerceToAsyncValidator(validators);
      }

      addValidators(validators) {
        this.setValidators(addValidators(validators, this._rawValidators));
      }

      addAsyncValidators(validators) {
        this.setAsyncValidators(addValidators(validators, this._rawAsyncValidators));
      }

      removeValidators(validators) {
        this.setValidators(removeValidators(validators, this._rawValidators));
      }

      removeAsyncValidators(validators) {
        this.setAsyncValidators(removeValidators(validators, this._rawAsyncValidators));
      }

      hasValidator(validator) {
        return hasValidator(this._rawValidators, validator);
      }

      hasAsyncValidator(validator) {
        return hasValidator(this._rawAsyncValidators, validator);
      }

      clearValidators() {
        this.validator = null;
      }

      clearAsyncValidators() {
        this.asyncValidator = null;
      }

      markAsTouched(opts = {}) {
        this.touched = true;

        if (this._parent && !opts.onlySelf) {
          this._parent.markAsTouched(opts);
        }
      }

      markAllAsTouched() {
        this.markAsTouched({
          onlySelf: true
        });

        this._forEachChild(control => control.markAllAsTouched());
      }

      markAsUntouched(opts = {}) {
        this.touched = false;
        this._pendingTouched = false;

        this._forEachChild(control => {
          control.markAsUntouched({
            onlySelf: true
          });
        });

        if (this._parent && !opts.onlySelf) {
          this._parent._updateTouched(opts);
        }
      }

      markAsDirty(opts = {}) {
        this.pristine = false;

        if (this._parent && !opts.onlySelf) {
          this._parent.markAsDirty(opts);
        }
      }

      markAsPristine(opts = {}) {
        this.pristine = true;
        this._pendingDirty = false;

        this._forEachChild(control => {
          control.markAsPristine({
            onlySelf: true
          });
        });

        if (this._parent && !opts.onlySelf) {
          this._parent._updatePristine(opts);
        }
      }

      markAsPending(opts = {}) {
        this.status = PENDING;

        if (opts.emitEvent !== false) {
          this.statusChanges.emit(this.status);
        }

        if (this._parent && !opts.onlySelf) {
          this._parent.markAsPending(opts);
        }
      }

      disable(opts = {}) {
        const skipPristineCheck = this._parentMarkedDirty(opts.onlySelf);

        this.status = DISABLED;
        this.errors = null;

        this._forEachChild(control => {
          control.disable(_extends({}, opts, {
            onlySelf: true
          }));
        });

        this._updateValue();

        if (opts.emitEvent !== false) {
          this.valueChanges.emit(this.value);
          this.statusChanges.emit(this.status);
        }

        this._updateAncestors(_extends({}, opts, {
          skipPristineCheck
        }));

        this._onDisabledChange.forEach(changeFn => changeFn(true));
      }

      enable(opts = {}) {
        // If parent has been marked artificially dirty we don't want to re-calculate the
        // parent's dirtiness based on the children.
        const skipPristineCheck = this._parentMarkedDirty(opts.onlySelf);

        this.status = VALID;

        this._forEachChild(control => {
          control.enable(_extends({}, opts, {
            onlySelf: true
          }));
        });

        this.updateValueAndValidity({
          onlySelf: true,
          emitEvent: opts.emitEvent
        });

        this._updateAncestors(_extends({}, opts, {
          skipPristineCheck
        }));

        this._onDisabledChange.forEach(changeFn => changeFn(false));
      }

      _updateAncestors(opts) {
        if (this._parent && !opts.onlySelf) {
          this._parent.updateValueAndValidity(opts);

          if (!opts.skipPristineCheck) {
            this._parent._updatePristine();
          }

          this._parent._updateTouched();
        }
      }

      setParent(parent) {
        this._parent = parent;
      }

      updateValueAndValidity(opts = {}) {
        this._setInitialStatus();

        this._updateValue();

        if (this.enabled) {
          this._cancelExistingSubscription();

          this.errors = this._runValidator();
          this.status = this._calculateStatus();

          if (this.status === VALID || this.status === PENDING) {
            this._runAsyncValidator(opts.emitEvent);
          }
        }

        if (opts.emitEvent !== false) {
          this.valueChanges.emit(this.value);
          this.statusChanges.emit(this.status);
        }

        if (this._parent && !opts.onlySelf) {
          this._parent.updateValueAndValidity(opts);
        }
      }

      _updateTreeValidity(opts = {
        emitEvent: true
      }) {
        this._forEachChild(ctrl => ctrl._updateTreeValidity(opts));

        this.updateValueAndValidity({
          onlySelf: true,
          emitEvent: opts.emitEvent
        });
      }

      _setInitialStatus() {
        this.status = this._allControlsDisabled() ? DISABLED : VALID;
      }

      _runValidator() {
        return this.validator ? this.validator(this) : null;
      }

      _runAsyncValidator(emitEvent) {
        if (this.asyncValidator) {
          this.status = PENDING;
          this._hasOwnPendingAsyncValidator = true;
          const obs = toObservable(this.asyncValidator(this));
          this._asyncValidationSubscription = obs.subscribe(errors => {
            this._hasOwnPendingAsyncValidator = false;
            this.setErrors(errors, {
              emitEvent
            });
          });
        }
      }

      _cancelExistingSubscription() {
        if (this._asyncValidationSubscription) {
          this._asyncValidationSubscription.unsubscribe();

          this._hasOwnPendingAsyncValidator = false;
        }
      }

      setErrors(errors, opts = {}) {
        this.errors = errors;

        this._updateControlsErrors(opts.emitEvent !== false);
      }

      get(path) {
        return _find(this, path, ".");
      }

      getError(errorCode, path) {
        const control = path ? this.get(path) : this;
        return control && control.errors ? control.errors[errorCode] : null;
      }

      hasError(errorCode, path) {
        return !!this.getError(errorCode, path);
      }

      get root() {
        let x = this;

        while (x._parent) {
          x = x._parent;
        }

        return x;
      }
      /** @internal */


      _updateControlsErrors(emitEvent) {
        this.status = this._calculateStatus();

        if (emitEvent) {
          this.statusChanges.emit(this.status);
        }

        if (this._parent) {
          this._parent._updateControlsErrors(emitEvent);
        }
      }
      /** @internal */


      _initObservables() {
        this.valueChanges = new EventEmitter2();
        this.statusChanges = new EventEmitter2();
      }

      _calculateStatus() {
        if (this._allControlsDisabled()) return DISABLED;
        if (this.errors) return INVALID;
        if (this._hasOwnPendingAsyncValidator || this._anyControlsHaveStatus(PENDING)) return PENDING;
        if (this._anyControlsHaveStatus(INVALID)) return INVALID;
        return VALID;
      }
      /** @internal */


      /** @internal */
      _anyControlsHaveStatus(status) {
        return this._anyControls(control => control.status === status);
      }
      /** @internal */


      _anyControlsDirty() {
        return this._anyControls(control => control.dirty);
      }
      /** @internal */


      _anyControlsTouched() {
        return this._anyControls(control => control.touched);
      }
      /** @internal */


      _updatePristine(opts = {}) {
        this.pristine = !this._anyControlsDirty();

        if (this._parent && !opts.onlySelf) {
          this._parent._updatePristine(opts);
        }
      }
      /** @internal */


      _updateTouched(opts = {}) {
        this.touched = this._anyControlsTouched();

        if (this._parent && !opts.onlySelf) {
          this._parent._updateTouched(opts);
        }
      }
      /** @internal */


      /** @internal */
      _isBoxedValue(formState) {
        return typeof formState === "object" && formState !== null && Object.keys(formState).length === 2 && "value" in formState && "disabled" in formState;
      }
      /** @internal */


      _registerOnCollectionChange(fn) {
        this._onCollectionChange = fn;
      }
      /** @internal */


      _setUpdateStrategy(opts) {
        if (isOptionsObj(opts) && opts.updateOn != null) {
          this._updateOn = opts.updateOn;
        }
      }

      _parentMarkedDirty(onlySelf) {
        const parentDirty = this._parent && this._parent.dirty;
        return !onlySelf && !!parentDirty && !this._parent._anyControlsDirty();
      }

      getRoot() {
        if (this.parent) {
          return this.parent.getRoot();
        } else {
          return this;
        }
      }

    }
    class FormControl extends AbstractControl {
      constructor(formState = null, validatorOrOpts, asyncValidator) {
        super(pickValidators(validatorOrOpts), pickAsyncValidators(asyncValidator, validatorOrOpts));
        this._onChange = [];
        this._pendingValue = void 0;
        this._pendingChange = void 0;

        this.onChange = event => {
          const value = getControlValue(event);
          const isDirty = value !== this.value;

          if (this.updateOn !== "change") {
            this._pendingValue = value;
            this._pendingChange = true;

            if (isDirty && !this._pendingDirty) {
              this._pendingDirty = true;
            }
          } else {
            if (isDirty && !this.dirty) {
              this.markAsDirty();
            }

            this.setValue(value);
          }
        };

        this.onBlur = () => {
          if (this.updateOn === "blur") {
            if (this._pendingDirty && !this.dirty) {
              this.markAsDirty();
            }

            if (!this.touched) {
              this.markAsTouched();
            }

            this.setValue(this._pendingValue, {
              emitEvent: false,
              onlySelf: true
            });
          } else if (this.updateOn === "submit") {
            this._pendingTouched = true;
          } else {
            !this.touched;

            if (!this.touched) {
              this.markAsTouched();
              this.setValue(this.value);
            }
          }
        };

        this._applyFormState(formState);

        this._setUpdateStrategy(validatorOrOpts);

        this._initObservables();

        this.updateValueAndValidity({
          onlySelf: true,
          emitEvent: !!this.asyncValidator
        });
      }

      setValue(value, options = {}) {
        this.value = this._pendingValue = value;
        const root = this.getRoot();
        const reRender = root.reRender;
        reRender && reRender(Math.random());

        if (this._onChange.length && options.emitModelToViewChange !== false) {
          this._onChange.forEach(changeFn => changeFn(this.value, options.emitViewToModelChange !== false));
        }

        this.updateValueAndValidity(options);
      }

      patchValue(value, options = {}) {
        this.setValue(value, options);
      }

      reset(formState = null, options = {}) {
        this._applyFormState(formState);

        this.markAsPristine(options);
        this.markAsUntouched(options);
        this.setValue(this.value, options);
        this._pendingChange = false;
      }

      _updateValue() {}

      _anyControls(condition) {
        return false;
      }

      _allControlsDisabled() {
        return this.disabled;
      }

      registerOnChange(fn) {
        this._onChange.push(fn);
      }

      _unregisterOnChange(fn) {
        removeListItem(this._onChange, fn);
      }

      registerOnDisabledChange(fn) {
        this._onDisabledChange.push(fn);
      }

      _unregisterOnDisabledChange(fn) {
        removeListItem(this._onDisabledChange, fn);
      }

      _forEachChild(cb) {}

      _syncPendingControls() {
        if (this.updateOn === "submit") {
          if (this._pendingDirty) this.markAsDirty();
          if (this._pendingTouched) this.markAsTouched();

          if (this._pendingChange) {
            this.setValue(this._pendingValue, {
              onlySelf: true,
              emitModelToViewChange: false
            });
            return true;
          }
        }

        return false;
      }

      _applyFormState(formState) {
        if (this._isBoxedValue(formState)) {
          this.value = this._pendingValue = formState.value;
          formState.disabled ? this.disable({
            onlySelf: true,
            emitEvent: false
          }) : this.enable({
            onlySelf: true,
            emitEvent: false
          });
        } else {
          this.value = this._pendingValue = formState;
        }
      }

    }
    class FormGroup extends AbstractControl {
      constructor(controls, validatorOrOpts, asyncValidator) {
        super(pickValidators(validatorOrOpts), pickAsyncValidators(asyncValidator, validatorOrOpts));
        this.controls = controls;

        this._initObservables();

        this._setUpdateStrategy(validatorOrOpts);

        this._setUpControls();

        this.updateValueAndValidity({
          onlySelf: true,
          emitEvent: !!this.asyncValidator
        });
      }

      registerControl(name, control) {
        if (this.controls[name]) return this.controls[name];
        this.controls[name] = control;
        control.setParent(this);

        control._registerOnCollectionChange(this._onCollectionChange);

        return control;
      }

      addControl(name, control, options = {}) {
        this.registerControl(name, control);
        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });

        this._onCollectionChange();
      }

      removeControl(name, options = {}) {
        if (this.controls[name]) this.controls[name]._registerOnCollectionChange(() => {});
        delete this.controls[name];
        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });

        this._onCollectionChange();
      }

      setControl(name, control, options = {}) {
        if (this.controls[name]) this.controls[name]._registerOnCollectionChange(() => {});
        delete this.controls[name];
        if (control) this.registerControl(name, control);
        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });

        this._onCollectionChange();
      }

      contains(controlName) {
        return this.controls.hasOwnProperty(controlName) && this.controls[controlName].enabled;
      }

      setValue(value, options = {}) {
        this._checkAllValuesPresent(value);

        Object.keys(value).forEach(name => {
          this._throwIfControlMissing(name);

          this.controls[name].setValue(value[name], {
            onlySelf: true,
            emitEvent: options.emitEvent
          });
        });
        this.updateValueAndValidity(options);
      }

      patchValue(value, options = {}) {
        if (value == null
        /* both `null` and `undefined` */
        ) return;
        Object.keys(value).forEach(name => {
          if (this.controls[name]) {
            this.controls[name].patchValue(value[name], {
              onlySelf: true,
              emitEvent: options.emitEvent
            });
          }
        });
        this.updateValueAndValidity(options);
        const root = this.getRoot();
        const reRender = root.reRender;
        reRender && reRender(Math.random());
      }

      reset(value = {}, options = {}) {
        this._forEachChild((control, name) => {
          control.reset(value[name], {
            onlySelf: true,
            emitEvent: options.emitEvent
          });
        });

        this._updatePristine(options);

        this._updateTouched(options);

        this.updateValueAndValidity(options);
      }

      getRawValue() {
        return this._reduceChildren({}, (acc, control, name) => {
          acc[name] = control instanceof FormControl ? control.value : control.getRawValue();
          return acc;
        });
      }

      _syncPendingControls() {
        let subtreeUpdated = this._reduceChildren(false, (updated, child) => {
          return child._syncPendingControls() ? true : updated;
        });

        if (subtreeUpdated) this.updateValueAndValidity({
          onlySelf: true
        });
        return subtreeUpdated;
      }

      _throwIfControlMissing(name) {
        if (!Object.keys(this.controls).length) {
          throw new Error(`
         There are no form controls registered with this group yet. If you're using ngModel,
         you may want to check next tick (e.g. use setTimeout).
       `);
        }

        if (!this.controls[name]) {
          throw new Error(`Cannot find form control with name: ${name}.`);
        }
      }

      _forEachChild(cb) {
        Object.keys(this.controls).forEach(key => {
          const control = this.controls[key];
          control && cb(control, key);
        });
      }

      _setUpControls() {
        this._forEachChild((control, key) => {
          control.setParent(this);

          control._registerOnCollectionChange(this._onCollectionChange);
        });
      }

      _updateValue() {
        this.value = this._reduceValue();
      }

      _anyControls(condition) {
        for (const controlName of Object.keys(this.controls)) {
          const control = this.controls[controlName];

          if (this.contains(controlName) && condition(control)) {
            return true;
          }
        }

        return false;
      }

      _reduceValue() {
        return this._reduceChildren({}, (acc, control, name) => {
          if (control.enabled || this.disabled) {
            acc[name] = control.value;
          }

          return acc;
        });
      }
      /** @internal */


      _reduceChildren(initValue, fn) {
        let res = initValue;

        this._forEachChild((control, name) => {
          res = fn(res, control, name);
        });

        return res;
      }

      _allControlsDisabled() {
        for (const controlName of Object.keys(this.controls)) {
          if (this.controls[controlName].enabled) {
            return false;
          }
        }

        return Object.keys(this.controls).length > 0 || this.disabled;
      }
      /** @internal */


      _checkAllValuesPresent(value) {
        this._forEachChild((control, name) => {
          if (value[name] === undefined) {
            throw new Error(`Must supply a value for form control with name: '${name}'.`);
          }
        });
      }

    }
    class FormArray extends AbstractControl {
      constructor(controls, validatorOrOpts, asyncValidator) {
        super(pickValidators(validatorOrOpts), pickAsyncValidators(asyncValidator, validatorOrOpts));
        this.controls = controls;

        this._initObservables();

        this._setUpdateStrategy(validatorOrOpts);

        this._setUpControls();

        this.updateValueAndValidity({
          onlySelf: true,
          emitEvent: !!this.asyncValidator
        });
      }

      at(index) {
        return this.controls[index];
      }

      push(control, options = {}) {
        this.controls.push(control);

        this._registerControl(control);

        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });

        this._onCollectionChange();

        const root = this.getRoot();
        const reRender = root.reRender;
        reRender && reRender(Math.random());
      }

      insert(index, control, options = {}) {
        this.controls.splice(index, 0, control);

        this._registerControl(control);

        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });
        const root = this.getRoot();
        const reRender = root.reRender;
        reRender && reRender(Math.random());
      }

      removeAt(index, options = {}) {
        if (this.controls[index]) this.controls[index]._registerOnCollectionChange(() => {});
        this.controls.splice(index, 1);
        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });
        const root = this.getRoot();
        const reRender = root.reRender;
        reRender && reRender(Math.random());
      }

      setControl(index, control, options = {}) {
        if (this.controls[index]) this.controls[index]._registerOnCollectionChange(() => {});
        this.controls.splice(index, 1);

        if (control) {
          this.controls.splice(index, 0, control);

          this._registerControl(control);
        }

        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });

        this._onCollectionChange();

        const root = this.getRoot();
        const reRender = root.reRender;
        reRender && reRender(Math.random());
      }

      get length() {
        return this.controls.length;
      }

      setValue(value, options = {}) {
        this._checkAllValuesPresent(value);

        value.forEach((newValue, index) => {
          this._throwIfControlMissing(index);

          this.at(index).setValue(newValue, {
            onlySelf: true,
            emitEvent: options.emitEvent
          });
        });
        this.updateValueAndValidity(options);
      }

      patchValue(value, options = {}) {
        if (value == null
        /* both `null` and `undefined` */
        ) return;
        value.forEach((newValue, index) => {
          if (this.at(index)) {
            this.at(index).patchValue(newValue, {
              onlySelf: true,
              emitEvent: options.emitEvent
            });
          }
        });
        this.updateValueAndValidity(options);
      }

      reset(value = [], options = {}) {
        this._forEachChild((control, index) => {
          control.reset(value[index], {
            onlySelf: true,
            emitEvent: options.emitEvent
          });
        });

        this._updatePristine(options);

        this._updateTouched(options);

        this.updateValueAndValidity(options);
      }

      getRawValue() {
        return this.controls.map(control => {
          return control instanceof FormControl ? control.value : control.getRawValue();
        });
      }

      clear(options = {}) {
        if (this.controls.length < 1) return;

        this._forEachChild(control => control._registerOnCollectionChange(() => {}));

        this.controls.splice(0);
        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });
      }

      _syncPendingControls() {
        let subtreeUpdated = this.controls.reduce((updated, child) => {
          return child._syncPendingControls() ? true : updated;
        }, false);
        if (subtreeUpdated) this.updateValueAndValidity({
          onlySelf: true
        });
        return subtreeUpdated;
      }

      _throwIfControlMissing(index) {
        if (!this.controls.length) {
          throw new Error(`
         There are no form controls registered with this array yet. If you're using ngModel,
         you may want to check next tick (e.g. use setTimeout).
       `);
        }

        if (!this.at(index)) {
          throw new Error(`Cannot find form control at index ${index}`);
        }
      }

      _forEachChild(cb) {
        this.controls.forEach((control, index) => {
          cb(control, index);
        });
      }

      _updateValue() {
        this.value = this.controls.filter(control => control.enabled || this.disabled).map(control => control.value);
      }

      _anyControls(condition) {
        return this.controls.some(control => control.enabled && condition(control));
      }

      _setUpControls() {
        this._forEachChild((control, index) => {
          this._registerControl(control);
        });
      }

      _checkAllValuesPresent(value) {
        this._forEachChild((control, i) => {
          if (value[i] === undefined) {
            throw new Error(`Must supply a value for form control at index: ${i}.`);
          }
        });
      }

      _allControlsDisabled() {
        for (const control of this.controls) {
          if (control.enabled) return false;
        }

        return this.controls.length > 0 || this.disabled;
      }

      _registerControl(control) {
        control.setParent(this);

        control._registerOnCollectionChange(this._onCollectionChange);
      }

    }

    function getControlValue(event) {
      if (isEvent(event)) {
        switch (event.target.type) {
          case "checkbox":
            return event.target.checked;

          case "select-multiple":
            if (event.target.options) {
              let options = event.target.options;
              var value = [];

              for (var i = 0, l = options.length; i < l; i++) {
                if (options[i].selected) {
                  value.push(options[i].value);
                }
              }

              return value;
            }

            return event.target.value;

          case "number":
            return event.target.valueAsNumber;

          default:
            return isReactNative() ? event.nativeEvent.text : event.target.value;
        }
      }

      return event;
    }

    const isReactNative = () => typeof window !== "undefined" && window.navigator && window.navigator.product && window.navigator.product === "ReactNative";
    const isEvent = candidate => !!(candidate && candidate.stopPropagation && candidate.preventDefault);

    function isAbstractControlOptions(options) {
      return options.asyncValidators !== undefined || options.validators !== undefined || options.updateOn !== undefined;
    }
    /**
     * @description
     * Creates an `AbstractControl` from a user-specified configuration.
     *
     * The `FormBuilder` provides syntactic sugar that shortens creating instances of a `FormControl`,
     * `FormGroup`, or `FormArray`. It reduces the amount of boilerplate needed to build complex
     * forms.
     *
     * @see [Reactive Forms Guide](/guide/reactive-forms)
     *
     * @publicApi
     */


    class FormBuilder {
      /**
       * @description
       * Construct a new `FormGroup` instance.
       *
       * @param controlsConfig A collection of child controls. The key for each child is the name
       * under which it is registered.
       *
       * @param options Configuration options object for the `FormGroup`. The object should have the
       * the `AbstractControlOptions` type and might contain the following fields:
       * * `validators`: A synchronous validator function, or an array of validator functions
       * * `asyncValidators`: A single async validator or array of async validator functions
       * * `updateOn`: The event upon which the control should be updated (options: 'change' | 'blur' |
       * submit')
       */

      /**
       * @description
       * Construct a new `FormGroup` instance.
       *
       * @deprecated This API is not typesafe and can result in issues with Closure Compiler renaming.
       * Use the `FormBuilder#group` overload with `AbstractControlOptions` instead.
       * Note that `AbstractControlOptions` expects `validators` and `asyncValidators` to be valid
       * validators. If you have custom validators, make sure their validation function parameter is
       * `AbstractControl` and not a sub-class, such as `FormGroup`. These functions will be called with
       * an object of type `AbstractControl` and that cannot be automatically downcast to a subclass, so
       * TypeScript sees this as an error. For example, change the `(group: FormGroup) =>
       * ValidationErrors|null` signature to be `(group: AbstractControl) => ValidationErrors|null`.
       *
       * @param controlsConfig A collection of child controls. The key for each child is the name
       * under which it is registered.
       *
       * @param options Configuration options object for the `FormGroup`. The legacy configuration
       * object consists of:
       * * `validator`: A synchronous validator function, or an array of validator functions
       * * `asyncValidator`: A single async validator or array of async validator functions
       * Note: the legacy format is deprecated and might be removed in one of the next major versions
       * of Angular.
       */
      group(controlsConfig, options = null) {
        const controls = this._reduceControls(controlsConfig);

        let validators = null;
        let asyncValidators = null;
        let updateOn = undefined;

        if (options != null) {
          if (isAbstractControlOptions(options)) {
            validators = options.validators != null ? options.validators : null;
            asyncValidators = options.asyncValidators != null ? options.asyncValidators : null;
            updateOn = options.updateOn != null ? options.updateOn : undefined;
          } else {
            validators = options["validator"] != null ? options["validator"] : null;
            asyncValidators = options["asyncValidator"] != null ? options["asyncValidator"] : null;
          }
        }

        return new FormGroup(controls, {
          asyncValidators,
          updateOn,
          validators
        });
      }
      /**
       * @description
       * Construct a new `FormControl` with the given state, validators and options.
       *
       * @param formState Initializes the control with an initial state value, or
       * with an object that contains both a value and a disabled status.
       *
       * @param validatorOrOpts A synchronous validator function, or an array of
       * such functions, or an `AbstractControlOptions` object that contains
       * validation functions and a validation trigger.
       *
       * @param asyncValidator A single async validator or array of async validator
       * functions.
       *
       * @usageNotes
       *
       * ### Initialize a control as disabled
       *
       * The following example returns a control with an initial value in a disabled state.
       *
       * <code-example path="forms/ts/formBuilder/form_builder_example.ts" region="disabled-control">
       * </code-example>
       */


      control(formState, validatorOrOpts, asyncValidator) {
        return new FormControl(formState, validatorOrOpts, asyncValidator);
      }
      /**
       * Constructs a new `FormArray` from the given array of configurations,
       * validators and options.
       *
       * @param controlsConfig An array of child controls or control configs. Each
       * child control is given an index when it is registered.
       *
       * @param validatorOrOpts A synchronous validator function, or an array of
       * such functions, or an `AbstractControlOptions` object that contains
       * validation functions and a validation trigger.
       *
       * @param asyncValidator A single async validator or array of async validator
       * functions.
       */


      array(controlsConfig, validatorOrOpts, asyncValidator) {
        const controls = controlsConfig.map(c => this._createControl(c));
        return new FormArray(controls, validatorOrOpts, asyncValidator);
      }
      /** @internal */


      _reduceControls(controlsConfig) {
        const controls = {};
        Object.keys(controlsConfig).forEach(controlName => {
          controls[controlName] = this._createControl(controlsConfig[controlName]);
        });
        return controls;
      }
      /** @internal */


      _createControl(controlConfig) {
        if (controlConfig instanceof FormControl || controlConfig instanceof FormGroup || controlConfig instanceof FormArray) {
          return controlConfig;
        } else if (Array.isArray(controlConfig)) {
          const value = controlConfig[0];
          const validator = controlConfig.length > 1 ? controlConfig[1] : null;
          const asyncValidator = controlConfig.length > 2 ? controlConfig[2] : null;
          return this.control(value, validator, asyncValidator);
        } else {
          return this.control(controlConfig);
        }
      }

    }

    const useFormBuilder = () => {
      const formBuilderRef = React.useRef(new FormBuilder());
      return formBuilderRef.current;
    };

    const useFormGroup = () => {
      const [, reRender] = React.useState(0);
      const formGroupRef = React.useRef(new FormGroup({}));
      const setFormGroup$Ref = React.useRef(new rxjs.Subject());
      const destroy$Ref = React.useRef(new rxjs.Subject());
      const setFormGroupRef = React.useRef(setFormGroup$Ref.current.next.bind(setFormGroup$Ref.current));
      const getFormGroupRef = React.useRef(() => formGroupRef.current);
      React.useEffect(() => {
        setFormGroup$Ref.current.pipe(takeUntil(destroy$Ref.current), filter(formGroup => formGroup !== formGroupRef.current), tap(formGroup => {
          formGroupRef.current = formGroup;
          formGroupRef.current.reRender = reRender;
        }), delay(1), tap(() => {
          reRender(Math.random());
        })).subscribe();
      }, []);
      return {
        setFormGroup: setFormGroupRef.current,
        getFormGroup: getFormGroupRef.current
      };
    };

    function toNumber(value) {
      return typeof value === "number" ? value : parseInt(value, 10);
    }

    class AbstractValidatorDirective {
      constructor() {
        this._validator = nullValidator;
        this._onChange = void 0;
        this.inputName = void 0;
      }

      handleChanges(changes) {
        if (this.inputName in changes) {
          const input = this.normalizeInput(changes[this.inputName].currentValue);
          this._validator = this.createValidator(input);

          if (this._onChange) {
            this._onChange();
          }
        }
      }

      validate(control) {
        return this._validator(control);
      }

      registerOnValidatorChange(fn) {
        this._onChange = fn;
      }

    }

    class MaxValidator extends AbstractValidatorDirective {
      constructor(...args) {
        super(...args);
        this.max = void 0;
        this.inputName = "max";

        this.normalizeInput = input => parseFloat(input);

        this.createValidator = max => maxValidator(max);
      }

      ngOnChanges(changes) {
        this.handleChanges(changes);
      }

    }
    /**
     * @description
     * Provider which adds `MinValidator` to the `NG_VALIDATORS` multi-provider list.
     */

    /**
     * A directive which installs the {@link MinValidator} for any `formControlName`,
     * `formControl`, or control with `ngModel` that also has a `min` attribute.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * @usageNotes
     *
     * ### Adding a min validator
     *
     * The following example shows how to add a min validator to an input attached to an
     * ngModel binding.
     *
     * ```html
     * <input type="number" ngModel min="4">
     * ```
     *
     * @ngModule ReactiveFormsModule
     * @ngModule FormsModule
     * @publicApi
     */

    class MinValidator extends AbstractValidatorDirective {
      constructor(...args) {
        super(...args);
        this.min = void 0;
        this.inputName = "min";

        this.normalizeInput = input => parseFloat(input);

        this.createValidator = min => minValidator(min);
      }

      /**
       * Declare `ngOnChanges` lifecycle hook at the main directive level (vs keeping it in base class)
       * to avoid differences in handling inheritance of lifecycle hooks between Ivy and ViewEngine in
       * AOT mode. This could be refactored once ViewEngine is removed.
       * @nodoc
       */
      ngOnChanges(changes) {
        this.handleChanges(changes);
      }

    }
    /**
     * @description
     * An interface implemented by classes that perform asynchronous validation.
     *
     * @usageNotes
     *
     * ### Provide a custom async validator directive
     *
     * The following example implements the `AsyncValidator` interface to create an
     * async validator directive with a custom error key.
     *
     * ```typescript
     * import { of } from 'rxjs';
     *
     * @Directive({
     *   selector: '[customAsyncValidator]',
     *   providers: [{provide: NG_ASYNC_VALIDATORS, useExisting: CustomAsyncValidatorDirective, multi:
     * true}]
     * })
     * class CustomAsyncValidatorDirective implements AsyncValidator {
     *   validate(control: AbstractControl): Observable<ValidationErrors|null> {
     *     return of({'custom': true});
     *   }
     * }
     * ```
     *
     * @publicApi
     */

    /**
     * @description
     * Provider which adds `RequiredValidator` to the `NG_VALIDATORS` multi-provider list.
     */

    /**
     * @description
     * Provider which adds `CheckboxRequiredValidator` to the `NG_VALIDATORS` multi-provider list.
     */

    /**
     * @description
     * A directive that adds the `required` validator to any controls marked with the
     * `required` attribute. The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * @usageNotes
     *
     * ### Adding a required validator using template-driven forms
     *
     * ```
     * <input name="fullName" ngModel required>
     * ```
     *
     * @ngModule FormsModule
     * @ngModule ReactiveFormsModule
     * @publicApi
     */
    class RequiredValidator {
      constructor() {
        this._required = false;
        this._onChange = void 0;
      }

      /**
       * @description
       * Tracks changes to the required attribute bound to this directive.
       */
      get required() {
        return this._required;
      }

      set required(value) {
        this._required = value != null && value !== false && `${value}` !== "false";
        if (this._onChange) this._onChange();
      }
      /**
       * Method that validates whether the control is empty.
       * Returns the validation result if enabled, otherwise null.
       * @nodoc
       */


      validate(control) {
        return this.required ? requiredValidator(control) : null;
      }
      /**
       * Registers a callback function to call when the validator inputs change.
       * @nodoc
       */


      registerOnValidatorChange(fn) {
        this._onChange = fn;
      }

    }
    /**
     * A Directive that adds the `required` validator to checkbox controls marked with the
     * `required` attribute. The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * @usageNotes
     *
     * ### Adding a required checkbox validator using template-driven forms
     *
     * The following example shows how to add a checkbox required validator to an input attached to an
     * ngModel binding.
     *
     * ```
     * <input type="checkbox" name="active" ngModel required>
     * ```
     *
     * @publicApi
     * @ngModule FormsModule
     * @ngModule ReactiveFormsModule
     */

    class CheckboxRequiredValidator extends RequiredValidator {
      /**
       * Method that validates whether or not the checkbox has been checked.
       * Returns the validation result if enabled, otherwise null.
       * @nodoc
       */
      //  override validate(control: AbstractControl): ValidationErrors|null {
      validate(control) {
        return this.required ? requiredTrueValidator(control) : null;
      }

    }
    /**
     * @description
     * Provider which adds `EmailValidator` to the `NG_VALIDATORS` multi-provider list.
     */

    /**
     * A directive that adds the `email` validator to controls marked with the
     * `email` attribute. The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * @usageNotes
     *
     * ### Adding an email validator
     *
     * The following example shows how to add an email validator to an input attached to an ngModel
     * binding.
     *
     * ```
     * <input type="email" name="email" ngModel email>
     * <input type="email" name="email" ngModel email="true">
     * <input type="email" name="email" ngModel [email]="true">
     * ```
     *
     * @publicApi
     * @ngModule FormsModule
     * @ngModule ReactiveFormsModule
     */

    class EmailValidator {
      constructor() {
        this._enabled = false;
        this._onChange = void 0;
      }

      /**
       * @description
       * Tracks changes to the email attribute bound to this directive.
       */
      set email(value) {
        this._enabled = value === "" || value === true || value === "true";
        if (this._onChange) this._onChange();
      }
      /**
       * Method that validates whether an email address is valid.
       * Returns the validation result if enabled, otherwise null.
       * @nodoc
       */


      validate(control) {
        return this._enabled ? emailValidator(control) : null;
      }
      /**
       * Registers a callback function to call when the validator inputs change.
       * @nodoc
       */


      registerOnValidatorChange(fn) {
        this._onChange = fn;
      }

    }
    /**
     * @description
     * A function that receives a control and synchronously returns a map of
     * validation errors if present, otherwise null.
     *
     * @publicApi
     */

    /**
     * @description
     * Provider which adds `MinLengthValidator` to the `NG_VALIDATORS` multi-provider list.
     */

    /**
     * A directive that adds minimum length validation to controls marked with the
     * `minlength` attribute. The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * @usageNotes
     *
     * ### Adding a minimum length validator
     *
     * The following example shows how to add a minimum length validator to an input attached to an
     * ngModel binding.
     *
     * ```html
     * <input name="firstName" ngModel minlength="4">
     * ```
     *
     * @ngModule ReactiveFormsModule
     * @ngModule FormsModule
     * @publicApi
     */
    class MinLengthValidator {
      constructor() {
        this._validator = nullValidator;
        this._onChange = void 0;
        this.minlength = void 0;
      }

      // This input is always defined, since the name matches selector.

      /** @nodoc */
      ngOnChanges(changes) {
        if ("minlength" in changes) {
          this._createValidator();

          if (this._onChange) this._onChange();
        }
      }
      /**
       * Method that validates whether the value meets a minimum length requirement.
       * Returns the validation result if enabled, otherwise null.
       * @nodoc
       */


      validate(control) {
        return this.enabled() ? this._validator(control) : null;
      }
      /**
       * Registers a callback function to call when the validator inputs change.
       * @nodoc
       */


      registerOnValidatorChange(fn) {
        this._onChange = fn;
      }

      _createValidator() {
        this._validator = this.enabled() ? minLengthValidator(toNumber(this.minlength)) : nullValidator;
      }
      /** @nodoc */


      enabled() {
        return this.minlength != null
        /* both `null` and `undefined` */
        ;
      }

    }
    /**
     * @description
     * Provider which adds `MaxLengthValidator` to the `NG_VALIDATORS` multi-provider list.
     */

    /**
     * A directive that adds max length validation to controls marked with the
     * `maxlength` attribute. The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * @usageNotes
     *
     * ### Adding a maximum length validator
     *
     * The following example shows how to add a maximum length validator to an input attached to an
     * ngModel binding.
     *
     * ```html
     * <input name="firstName" ngModel maxlength="25">
     * ```
     *
     * @ngModule ReactiveFormsModule
     * @ngModule FormsModule
     * @publicApi
     */

    class MaxLengthValidator {
      constructor() {
        this._validator = nullValidator;
        this._onChange = void 0;
        this.maxlength = void 0;
      }

      // This input is always defined, since the name matches selector.

      /** @nodoc */
      ngOnChanges(changes) {
        if ("maxlength" in changes) {
          this._createValidator();

          if (this._onChange) this._onChange();
        }
      }
      /**
       * Method that validates whether the value exceeds the maximum length requirement.
       * @nodoc
       */


      validate(control) {
        return this.enabled() ? this._validator(control) : null;
      }
      /**
       * Registers a callback function to call when the validator inputs change.
       * @nodoc
       */


      registerOnValidatorChange(fn) {
        this._onChange = fn;
      }

      _createValidator() {
        this._validator = this.enabled() ? maxLengthValidator(toNumber(this.maxlength)) : nullValidator;
      }
      /** @nodoc */


      enabled() {
        return this.maxlength != null
        /* both `null` and `undefined` */
        ;
      }

    }
    /**
     * @description
     * Provider which adds `PatternValidator` to the `NG_VALIDATORS` multi-provider list.
     */

    /**
     * @description
     * A directive that adds regex pattern validation to controls marked with the
     * `pattern` attribute. The regex must match the entire control value.
     * The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * @usageNotes
     *
     * ### Adding a pattern validator
     *
     * The following example shows how to add a pattern validator to an input attached to an
     * ngModel binding.
     *
     * ```html
     * <input name="firstName" ngModel pattern="[a-zA-Z ]*">
     * ```
     *
     * @ngModule ReactiveFormsModule
     * @ngModule FormsModule
     * @publicApi
     */

    class PatternValidator {
      constructor() {
        this._validator = nullValidator;
        this._onChange = void 0;
        this.pattern = void 0;
      }

      // This input is always defined, since the name matches selector.

      /** @nodoc */
      ngOnChanges(changes) {
        if ("pattern" in changes) {
          this._createValidator();

          if (this._onChange) this._onChange();
        }
      }
      /**
       * Method that validates whether the value matches the pattern requirement.
       * @nodoc
       */


      validate(control) {
        return this._validator(control);
      }
      /**
       * Registers a callback function to call when the validator inputs change.
       * @nodoc
       */


      registerOnValidatorChange(fn) {
        this._onChange = fn;
      }

      _createValidator() {
        this._validator = patternValidator(this.pattern);
      }

    }

    exports.AbstractControl = AbstractControl;
    exports.CheckboxRequiredValidator = CheckboxRequiredValidator;
    exports.DISABLED = DISABLED;
    exports.EmailValidator = EmailValidator;
    exports.EventEmitter2 = EventEmitter2;
    exports.FormArray = FormArray;
    exports.FormControl = FormControl;
    exports.FormGroup = FormGroup;
    exports.INVALID = INVALID;
    exports.InputContainer = InputContainer;
    exports.MaxLengthValidator = MaxLengthValidator;
    exports.MaxValidator = MaxValidator;
    exports.MinLengthValidator = MinLengthValidator;
    exports.MinValidator = MinValidator;
    exports.PENDING = PENDING;
    exports.PatternValidator = PatternValidator;
    exports.PrettyJson = PrettyJson;
    exports.RequiredValidator = RequiredValidator;
    exports.VALID = VALID;
    exports.Validators = Validators;
    exports.addValidators = addValidators;
    exports.composeAsyncValidators = composeAsyncValidators;
    exports.composeValidators = composeValidators;
    exports.emailValidator = emailValidator;
    exports.getControlAsyncValidators = getControlAsyncValidators;
    exports.getControlValidators = getControlValidators;
    exports.hasValidator = hasValidator;
    exports.isEvent = isEvent;
    exports.isReactNative = isReactNative;
    exports.makeValidatorsArray = makeValidatorsArray;
    exports.maxLengthValidator = maxLengthValidator;
    exports.maxValidator = maxValidator;
    exports.mergeValidators = mergeValidators;
    exports.minLengthValidator = minLengthValidator;
    exports.minValidator = minValidator;
    exports.normalizeValidators = normalizeValidators;
    exports.nullValidator = nullValidator;
    exports.patternValidator = patternValidator;
    exports.removeValidators = removeValidators;
    exports.requiredTrueValidator = requiredTrueValidator;
    exports.requiredValidator = requiredValidator;
    exports.toObservable = toObservable;
    exports.useFormBuilder = useFormBuilder;
    exports.useFormGroup = useFormGroup;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
